//********************************************************************************************
/**
 * @file		tools.h
 * @brief		Programable Application TOols Library wb_[.
 *
 *	DEBUG_TRACE  define `鎖 _` ̃fobOo͂LɂȂ܂
 *	
 *	pAv patold.lib winmm.lib N.
 *
 *	AvP[VɃCu񋟂ꍇ
 *		_STOOLS_H LɂďGۃ}NuC̓CN[hvkinclude.macʂƃTutH_ɂwb_[{wb_[ɑ}.
 *		TutH_ɂwb_[SĎłA܂͗pɓtH_\̃wb_[Q񋟂Ăǂ.
 *
 * @author		N.Takeda
 * @date		1998/01/07
 * @date		2011/07/31() 23:10:09	N.Takeda	stools
 */
//********************************************************************************************

#ifndef _TOOLS_H_ /* d`h~ */
#define _TOOLS_H_ /* d`h~}N */


#ifdef	_DEBUG
# define	DEBUG_TRACE	//Lɂ鎖 DEBUG_` ̃fobOo͂LɂȂ܂
#else
# define	_MASTER							///< fobOňȊO̓}X^[(bΏ)
#endif


/// vbgtH[`.
#if (defined( WIN32) && !defined(PLATFORM_WIN32))
# define	PLATFORM_WIN32
#elif (defined( SN_TARGET_PSP_PRX) && !defined(PLATFORM_PSP))
# define	PLATFORM_PSP
#endif


/**
 WIN32ŗL̐ݒ.
 */
#if defined( PLATFORM_WIN32 )
# define	WINDOWS_USE_COMMCTRL				///< RRg[g Lɂ鎞͗pAv comctl32.lib N.
# define	StreamOutTypeSJIS					///< Lɂ `_streamnS-JISɕϊĂo͂悤ɂȂ(_UNICODE).
#endif


//#define	_STOOLS_H					///< Lɂ stools.h [h. ʏvWFNgt@CɂĒ`
//#define	USE_OLD_PATOL


//	press/rls ł܂gpĂ镔̂łނ𓾂Ał邾Ή
#if defined( PLATFORM_WIN32 )
#ifndef	USE_OLD_PATOL
	struct MEMBUFF{
		HANDLE	hBuf;		//	nh
		LPVOID	lpBuf;		//	|C^
		UINT	fuFlags;	//	IuWFNg蓖đ
		BOOL	used;		//	mۂ TRUE
	};
	inline	BOOL	MEM_free(MEMBUFF *mem){
			
			if(mem->used == FALSE)	return FALSE;
			
			GlobalUnlock(mem->hBuf);
			if(GlobalFree(mem->hBuf) != NULL)	return FALSE;
			
			mem->used = FALSE;
			
			return TRUE;
	}
	inline	BOOL	MEM_alloc(MEMBUFF *mem,UINT Attr,DWORD Size){
			
			if(mem->used != FALSE)	MEM_free(mem);
			
			if(Size < 256)	Size = 256;
			mem->hBuf = GlobalAlloc( Attr, Size);
			if ( mem->hBuf == NULL )	return FALSE;				// [܂
			mem->lpBuf = GlobalLock( mem->hBuf );
			if ( mem->lpBuf == NULL )	return FALSE;				// [܂
			
			mem->fuFlags = Attr;
			mem->used = TRUE;
			
			return TRUE;
	}
#endif
#endif	// PLATFORM_WIN32

#ifdef	_STOOLS_H					///< 
// @include memory\tnew.h
//********************************************************************************************
/**
 * @file		tnew.h
 * @brief		AP[^.
	

__DATE__		݂̃\[X t@C̃RpCB̓t Mmm dd yyyy ̌`̕񃊃eł
__FILE__		݂̃\[X t@C̖OB__FILE__ ͓dpň͂܂ꂽɓWJ܂
__FUNCTION__	X̊֐݂̂ŗLłÅ֐Ɋ܂܂񑕏 () ߂܂
				/EP (#line fBNeBuȂ stdout ւ̑O) ܂ /P (t@Cւ̑O) RpC IvVgpꍇA__FUNCTION__ ͓WJ܂B
__LINE__		݂̃\[X t@C̍sԍB̍sԍ 10 i萔łB #line fBNeBugpĕύX邱Ƃł܂
__STDC__		ANSI C WɊSɏĂ邱Ƃ܂B
				/ZaA/Ze (g@\̖) RpC IvVw肵ĂāAC++ R[h̓RpCȂꍇɂ̂݁A萔 1 ƂĒ`܂BȊȌꍇ͒`܂B 
__TIME__		݂̃\[X t@C̍ŐṼRpCB̎ hh:mm:ss ̌`̕񃊃eł
__TIMESTAMP__	݂̃\[X t@C̍ŐV̕ύXBDdd Mmm Date hh:mm:ss yyyy (Ddd ͗j̏ȗ`ADate  1 ` 31 ̐) ̌`̕񃊃eƂĕ\܂

 * 
 * @author		N.Takeda
 * @date		2011/01/26() 22:02:04
 */
//********************************************************************************************

#ifndef	__tnew_h__	// d`h~
#define	__tnew_h__	// d`h~}N


#define	USE_MEMORY_OPERATE			///< operator new/deleteL`.


#ifdef	USE_MEMORY_OPERATE
//********************************************************************************************
/**
 * operator new/delete.
 */
//********************************************************************************************


enum EnMEM
{
	eMEM_common,					///< .
	eMEM_admin = -1,				///< }l[W[VXep. Av͎gp֎~.
	eMEM_nothing = eMEM_common,		///< ݒ荀. Ƃ肠ڐAȂǂāu܂ɕނĂȂ́vɎg.
};



#ifdef	_MASTER

void	*operator new(		size_t size,	const EnMEM _eAllocator );
void	*operator new[](	size_t size,	const EnMEM _eAllocator );
void	operator delete(	void* pv,		const EnMEM _eAllocator );
void	operator delete[](	void* pv,		const EnMEM _eAllocator );

/// new}N.
# define	tnew( _eAllocator )		new( _eAllocator )

#define	GetAllocSize()	(-1)

#else	// _MASTER

void	*operator new(		size_t size,	const EnMEM _eAllocator, const char* const _pFile, const int _iLine, const char* const _pFunc );
void	*operator new[](	size_t size,	const EnMEM _eAllocator, const char* const _pFile, const int _iLine, const char* const _pFunc );
void	operator delete(	void* pv,		const EnMEM _eAllocator, const char* const _pFile, const int _iLine, const char* const _pFunc );
void	operator delete[](	void* pv,		const EnMEM _eAllocator, const char* const _pFile, const int _iLine, const char* const _pFunc );

/// new}N.
# define	tnew( _eAllocator )		new( _eAllocator, __FILE__, __LINE__, __FUNCTION__)

int	GetAllocSize();

#endif	// _MASTER

/// delete}N. zɎgȂɃfXgN^Ă΂Ȃ.
#define	tdelete(pp)	operator delete (pp, __FILE__, __LINE__, __FUNCTION__)


#if 0	//vg^Cv錾͕sv݂
void	*operator new( size_t size );
void	operator delete( void* pv );
void	*operator new[]( size_t size );
void	operator delete[]( void* pv );
#endif


#else	// USE_MEMORY_OPERATE
//********************************************************************************************
/**
 * operator new/delete؂藣.
 */
//********************************************************************************************

#define	tnew( _eAllocator )		new


#endif	// USE_MEMORY_OPERATE


#endif // __tnew_h__
// @edulcni memory\tnew.h
// @include types.h
//********************************************************************************************
/**
 * @file		types.h
 * @brief		v
 *
 *	̃t@C̏ڍא
 *
 * @author		N.Takeda
 * @date		2010/10/08() 19:15:32
 */
//********************************************************************************************

#ifndef _TYPES_H__
#define _TYPES_H__



typedef	char				Int8;
typedef	unsigned char		UInt8;
typedef	short				Int16;
typedef	unsigned short		UInt16;
typedef	int					Int32;
typedef	unsigned int		UInt32;

#if defined( PLATFORM_WIN32 )
	typedef	__int64				Int64;
	typedef	unsigned __int64	UInt64;
	typedef	long				Int128;		///< \.
	typedef	unsigned long		UInt128;	///< \.

	typedef	BOOL				Bool;		///< booll.

#elif defined( PLATFORM_PSP )
	typedef	int					Int64;
	typedef	unsigned int		UInt64;
	typedef	long				Int128;		///< \.
	typedef	unsigned long		UInt128;	///< \.

	typedef	bool				Bool;		///< booll.
	#define	TRUE				true
	#define	FALSE				false
	#define	TEXT(_sString)		_sString

//	#define	ERROR				(-1)		///< t@C֘ÃG[R[hBp~̕
//	typedef	void*				LPVOID;		///< 

	#define	lstrcpy				strcpy
	#define	lstrcat				strcat
	#define	lstrlen				strlen
	#define	lstrcmp				strcmp

#endif


/*
|C^𐮐ɃLXg܂͂̋tsƂ͎̌^gpB

    IntPtr      |C^ƓTCY̕t
    UIntPtr     |C^ƓTCY̕Ȃ
*/


typedef	float				Float32;	///< Px(32bit).
typedef	double				Float64;	///< {x(64bit).



#if defined( PLATFORM_WIN32 )
/**
 ֘Awindows API.
 
 char		byteobt@
 TCHAR
 LPTSTR
 LPCTSTR
 */
/// .
#define		T_MAXDRIVE	_MAX_DRIVE
#define		T_MAXPATH	_MAX_PATH
#define		T_MAXDIR	_MAX_DIR
#define		T_MAXNAME	_MAX_FNAME
#define		T_MAXEXT	_MAX_EXT

#elif defined( PLATFORM_PSP )
typedef	char				TCHAR;		///< .
typedef	char*				LPTSTR;		///< .
typedef	const char*			LPCTSTR;	///< const.

typedef	short				WCHAR;		///< .
typedef	short*				LPWSTR;		///< .
typedef	const short*		LPCWSTR;	///< const.

/// .
#define		T_MAXDRIVE	(256)
#define		T_MAXPATH	(256)
#define		T_MAXDIR	(256)
#define		T_MAXNAME	(256)
#define		T_MAXEXT	(256)
#endif

#endif	// _TYPES_H__
// @edulcni types.h

/// windowsŗL
#if defined( PLATFORM_WIN32 )
// @include system\win32\assert.h
//********************************************************************************************
/**
 * @file		assert.h
 * @brief		v
 *
 *	̃t@C̏ڍא
 *
 * @author		N.Takeda
 * @date		2009/08/04() 15:06:40
 */
//********************************************************************************************

#ifndef __ASSERT_H__
#define __ASSERT_H__

#include <assert.h>

#ifndef	_STOOLS_H
#include "..\..\types.h"
#endif


#ifdef	_DEBUG

#define		ASSERT_STRING_LENGTH		(256)	///< assertbZ[Wő咷.

//{if ( (val) == 0 ){static dl_int32	__this_assertion_enable = 1;if ( __this_assertion_enable != 0 ) {	__this_assertion_enable = Debug_Assert((val), __FILE__, __LINE__, __FUNCTION__, __VA_ARGS__);if (!__this_assertion_enable) Debug_RegistAssertFlag(&__this_assertion_enable);}}

# define	T_ASSERT( _formula )					{t_Assert(  (Bool)(_formula), #_formula, __FILE__, __LINE__, __FUNCTION__, NULL );assert( _formula );}
# define	T_ASSERTC( _formula, _pFormat, ... )	{t_Assertc( (Bool)(_formula), #_formula, __FILE__, __LINE__, __FUNCTION__, _pFormat, __VA_ARGS__ );assert( _formula );}

void	t_Assert(  Bool _formula, const char *_sMethod, const char *_sFName, int _iLine, const char *_sFunc, LPCTSTR _sExpr );
void	t_Assertc( Bool _formula, const char *_sMethod, const char *_sFName, int _iLine, const char *_sFunc, LPCTSTR _pFormat, ... );

#else

# define	T_ASSERT( _formula )					__noop
# define	T_ASSERTC( _formula, _pFormat, ... )	__noop

#endif

#endif	// __ASSERT_H__
// @edulcni system\win32\assert.h
// @include system\win32\system.h
//********************************************************************************************
/**
 * @file		system.h
 * @brief		v
 *
 *	̃t@C̏ڍא
 *
 * @author		N.Takeda
 * @date		2009/08/20() 20:21:55
 */
//********************************************************************************************

#ifndef		_SYSTEM_H_
#define		_SYSTEM_H_

class MENU_HandleManager;					///< EBhEɑgݍނ߂̐錾


//	f[^p
//typedef	long		dword;


/// EBhE^Cv
enum EnWindowType
{
	enWindowTypeStandard,					///< ŏAő剻AEBhETCYϘg
	enWindowTypeOrthodox,					///< Standard TCYύX
	enWindowTypeMax,
};

/**
	EBhE\
 */
struct WINDOW_INFO
{
	LPCTSTR			m_pWndName;				///< EBhE̖O
	LPCTSTR			m_pWndTitle;			///< EBhE^Cgo[̕
	HWND			m_hWnd;					///< EBhEnh
	HINSTANCE		m_hInst;				///< AvP[ṼCX^X
	
	UInt32			m_uWndStyle;			///< EBhEX^C
	LPCTSTR			m_pWndMenu;				///< j[̃\[X
	Int32			m_iCmdShow;				///< EBhE\(^Cvɂď\Ԃ肳ꍇA_CreatełgȂ͂)
	Int32			m_iX;					///< EBhD\ʒux
	Int32			m_iY;					///< EBhD\ʒuy xftHg̏ꍇ͖
	Int32			m_iWidth;				///< EBhD
	Int32			m_iHight;				///< EBhD
	RECT			m_cRec;					///< ۂ̃EBhETCY (o[Aj[܂)
	
	HBRUSH			m_hBrush;				///< EBhE쐬ɎgpuV
	EnWindowType	m_eType;				///< EBhE^Cv PATOL Œ߂ꂽ`
	Bool			m_bMenu;				///< j[ TRUE
	Bool			m_bMenuUpdate;			///< j[XVtO
	
	HICON			m_hIcon;				///< ACRID
	HICON			m_hSIcon;				///< ACRID
	
#ifdef	WINDOWS_USE_COMMCTRL
	HWND			m_hStatus;				///< Xe[^Xo[
#endif
	
	WNDPROC			m_WndProc;				///< EBhEvV[W
	MENU_HandleManager	*m_pMenuHdMgr;		///< 


	WINDOW_INFO()
	 : m_pWndName( NULL )
	 , m_pWndTitle( NULL )
	 , m_hWnd( NULL )
#ifdef	WINDOWS_USE_COMMCTRL
	 , m_hStatus( NULL )
#endif
	 , m_hInst( 0 )
	 , m_pMenuHdMgr( NULL )
	{
		
	}
};

//********************************************************************************************
/**
 * @class		CWINDOW_NoMultiExec
 * @brief		
 * @author		N.Takeda
 * @date		2009/07/31() 20:41:54
 */
//********************************************************************************************
class	CWINDOW_NoMultiExec
{

	HANDLE		m_hMutex;
	HWND		m_hWnd;
	Bool		m_bIs;

public:
	Bool		Is(){	return m_bIs;	}
	
	HWND		GetAtherWnd(){	return m_hWnd;	}
	
	Bool		AnotherClose()
	{
		if( m_hWnd == NULL )	return TRUE;
		SendMessage( m_hWnd, WM_CLOSE, 0, 0 );
		if( !IsWindowEnabled( m_hWnd ) )	m_hWnd = NULL;
		
		return (m_hWnd == NULL);
	}
	
	void		AnotherActive()
	{
		if( IsWindowEnabled( m_hWnd ) )
			SetForegroundWindow( m_hWnd );
	}
	
	CWINDOW_NoMultiExec( LPCTSTR _pName )
	 : m_bIs( FALSE )
	 , m_hMutex( NULL )
	 , m_hWnd( NULL )
	{
		m_hMutex = CreateMutex ( NULL, FALSE, _pName );
		if( GetLastError ( ) == ERROR_ALREADY_EXISTS )
		{
			CloseHandle ( m_hMutex );
		}
		m_bIs = TRUE;
		m_hWnd = FindWindow( _pName, NULL );
	}

	~CWINDOW_NoMultiExec()
	{
		CloseHandle ( m_hMutex );
	}
};




WINDOW_INFO	WINDOW_SetStdInfo( LPCTSTR _pWndName, LPCTSTR _pTitle, const EnWindowType _eType, WNDPROC _pWndProc, const HINSTANCE _hInstance, const Int32 _iW = CW_USEDEFAULT, const Int32 _iH = CW_USEDEFAULT );

HWND	WINDOW_Create( WINDOW_INFO &_cWinfo, const Int32 _iCmdShow = -1 );

void	WINDOW_Destroy( WINDOW_INFO &_cWinfo );

void	WINDOW_Update( WINDOW_INFO &_cWinfo, const Int32 _iCmdShow = -1 );

void	WINDOW_SetSize( WINDOW_INFO &_cWinfo, const UInt32 _uW = 0, const UInt32 _uH = 0 );

void	WINDOW_SetMenu( WINDOW_INFO &_cWinfo, LPCTSTR _sMenu );

void	WINDOW_SetBackColor( WINDOW_INFO &_cWinfo, const Int32 _iCol );

Bool	WINDOW_Clear( WINDOW_INFO &_cWinfo );

#ifdef	WINDOWS_USE_COMMCTRL
Bool	WINDOW_STATUS_create( WINDOW_INFO &_cWinfo, const int *_Widths, const UINT32 _iID );

Bool	WINDOW_STATUS_text( WINDOW_INFO &_cWinfo, LPCTSTR _pString, const Int32 _iIdx = 0 );
#endif


/*----------------------------------------------------------
		eEChẺʃTCY߂B

Bool	WINDOW_displaySize( POINT *poScreenSize );

  
		POINT	ʂ\
  ߂l
  		̊֐ɂ͖߂l͂܂B
----------------------------------------------------------*/
void	WINDOW_displaySize( POINT *poScreenSize );


//	QdÑ`FbN
Bool	WINDOW_doubleExec(LPCTSTR m_pszExeName);



/// ڃ̗eʂ擾(byte).
UInt64	GetMem();
/// 󂫃̎擾(byte).
UInt64	GetFreeMem();


#endif	_SYSTEM_H_
// @edulcni system\win32\system.h
// @include system\win32\menu.h				///< system.h ̌
//********************************************************************************************
/**
 * @file		menu.h
 * @brief		v
 *
 *	̃t@C̏ڍא
 *
 * @author		N.Takeda
 * @date		2009/07/27() 18:36:33
 */
//********************************************************************************************

#ifndef		_MENU_H_
#define		_MENU_H_


/// [gID
#define		MENU_ID_ROOT		(0)


/// w肵ʒuɃj[}
void	WINDOW_MENU_insert( WINDOW_INFO &_cWin, const UInt32 _uID, LPTSTR _pStr, const UInt32 _uAddID, const UInt32 _uInsPos = (UInt32)-1 );
/// w肵ID̎OɃj[}
void	WINDOW_MENU_insertID( WINDOW_INFO &_cWin, const UInt32 _uID, LPTSTR _pStr, const UInt32 _uAddID, const UInt32 _uInsID );
/// j[폜(KwSč폜)
void	WINDOW_MENU_del( WINDOW_INFO &_cWin, const UInt32 _uID );

void	WINDOW_MENU_clear( WINDOW_INFO &_cWin );

/// j[j EBhETCY߂悤ȏ͂Ȃ(WINDOW_DestroyĂ΂Ă)
void	WINDOW_MENU_Destroy( WINDOW_INFO &_cWinfo );

/// j[̃`FbN}[NON/OFF
Bool	WINDOW_MENU_check( WINDOW_INFO &_cWin, const UInt32 _uID, const Int32 _bFlag = -1 );

/// w肵IDɃXgĂq̐𓾂.
Int32	WINDOW_MENU_GetEntry( WINDOW_INFO &_cWin, const UInt32 _uID );

Bool	WINDOW_MENU_GetString( WINDOW_INFO &_cWin, const UInt32 _uID, LPTSTR _pPtr, const Int32 _iBuffSize );


/**
	ʏ͊O͎gȂ.
*/
/// WINDOW_MENU_GetSub֐
HMENU	WINDOW_MENU_GetSub( WINDOW_INFO &_cWin, HMENU _hParentMenu, UInt32 _uID );

/// WINDOW_MENU_changeSub֐
HMENU	WINDOW_MENU_changeSub( WINDOW_INFO &_cWin, UInt32 _uAddID );

#endif	//	_MENU_H_
// @edulcni system\win32\menu.h				///< system.h ̌
// @include system\win32\profile.h
//********************************************************************************************
/**
 * @file		profile.h
 * @brief		vCx[gvt@CȒPɗp郉Cu
 *
 *	̃t@C̏ڍא
 *
 * @author		N.Takeda
 * @date		2009/08/20() 20:38:11
 */
//********************************************************************************************

#ifndef		_PROFILE_H_
#define		_PROFILE_H_



/// sAvP[VƓtH_ɂinit@C琔l擾
Int32	PROFILE_GetInt( LPCTSTR _sSec, LPCTSTR _sKey, const Int32 _iDefaule = -1 );

/// sAvP[VƓtH_ɂinit@CɐlZbg
void	PROFILE_SetInt( LPCTSTR _sSec, LPCTSTR _sKey, const Int32 _iVal );

/// sAvP[VƓtH_ɂinit@C當擾
Int32	PROFILE_GetString( LPCTSTR _sSec, LPCTSTR _sKey, LPTSTR _pString, const Int32 _iLength, LPCTSTR _pDefault = NULL );

/// sAvP[VƓtH_ɂinit@CɕZbg
void	PROFILE_SetString( LPCTSTR _sSec, LPCTSTR _sKey, LPCTSTR _pString );



#endif	//	_PROFILE_H_
// @edulcni system\win32\profile.h
// @include system\win32\clip.h
#ifndef CLIP_header /* d`h~ */
#define CLIP_header /* d`h~}N */



/*----------------------------------------------------------
	Nbv{[g蕶󂯎

LPSTR	CLIP_stringCut(HWND hWnd);

@
	HWND		EBhEnh
@߂l
	LPSTR		󂯎|C^(NULLI[)
----------------------------------------------------------*/
LPSTR	CLIP_stringCut(HWND hWnd);


/*----------------------------------------------------------
	Nbv{[gɑ΂A

int		CLIP_stringPaste(HWND hWnd,LPCTSTR str,int length);

@
	HWND		EBhEnh
	LPSTR		
	int			
@߂l
	int			IꍇA񂾕AȊO͂OԂ
----------------------------------------------------------*/
Int32	CLIP_stringPaste( char *str, Int32 _iLength, HWND _hWnd = NULL );


#endif /* CLIP_header */
// @edulcni system\win32\clip.h
// @include system\win32\help.h
//********************************************************************************************
/**
 * @file		help.h
 * @brief		v
	
		̃t@C̏ڍא
 * 
 * @author		N.Takeda
 */
//********************************************************************************************

#ifndef	_HELP_H_	// d`h~
#define	_HELP_H_	// d`h~}N

/*----------------------------------------------------------
		wvJ

Bool	HELP_open( HWND hWnd, const char* path );

@
	HWND	EBhEnh
	const char* wvt@C̃oX
  ߂l
	Bool	TRUE:I@FALSE:sł
----------------------------------------------------------*/
Bool	HELP_open( HWND hWnd, LPCTSTR path );


/*----------------------------------------------------------
		wv

Bool	HELP_close( HWND hWnd, const char* path );

@
	HWND	EBhEnh
	const char* wvt@C̃oX
  ߂l
	Bool	TRUE:I@FALSE:sł
----------------------------------------------------------*/
Bool	HELP_close( HWND hWnd, LPCTSTR path );


struct	FILESELECT
{
	HWND	hWnd;
	
	LPTSTR	szTitle;
	LPTSTR	szFullPathName;
	LPTSTR	DefFilename;
	LPTSTR	szFilter;
};


Bool	FILE_GetOpenFile(FILESELECT fs);
/*	l
@R_CAO{bNXAI[vt@CĂяoB

@Ăяo葱Ȍɂ邽ߕKvŒ̏\̉́B

	G[̏ڍׂ CommDlgExtendedError(); œ邱ƂłB

*/

Bool	FILE_GetSaveFile(FILESELECT fs);
/*	l
@R_CAO{bNXAI[vt@CĂяoB

@Ăяo葱Ȍɂ邽ߕKvŒ̏\̉́B

	G[̏ڍׂ CommDlgExtendedError(); œ邱ƂłB

*/


Bool	FILE_GetOpenFileEZ(HWND hWnd,LPTSTR Buff);
/*	l
@R_CAO{bNXAI[vt@CĂяoB
eEBhEnhnŁAt@C̃|C^ԂB

@c[fobOŁAȌɌĂяoꍇɎgpB

	G[̏ڍׂ CommDlgExtendedError(); œ邱ƂłB

*/

Bool	FILE_GetSaveFileEZ(HWND hWnd,LPTSTR Buff);
/*	l
@R_CAO{bNXAI[vt@CĂяoB
eEBhEnhnŁAt@C̃|C^ԂB

@c[fobOŁAȌɌĂяoꍇɎgpB

	G[̏ڍׂ CommDlgExtendedError(); œ邱ƂłB

*/


#endif // _HELP_H_ d`h~
// @edulcni system\win32\help.h

// @include files\files.h
//********************************************************************************************
/**
 * @file		files.h.
 * @brief		t@C.
 *
 *	̃t@C̏ڍא.
 *
 * @author		N.Takeda
 */
//********************************************************************************************

#ifndef _INCLUDE_FILES_H_ /* d`h~ */
#define _INCLUDE_FILES_H_ /* d`h~}N */

#include <stdio.h>


#define FILESTREAM_LENGTH		(1024)


/// G[l.
enum
{
	enFILE_ERROR = -1,
};

/// t@Cnh`.
#if defined( PLATFORM_WIN32 )

	typedef	HANDLE		FHND;
	#define	FILE_ERROR	reinterpret_cast<FHND>(enFILE_ERROR)

#elif defined( PLATFORM_PSP )

	typedef	SceUID		FHND;
	#define	FILE_ERROR	enFILE_ERROR
	
	#define	FILE_ATTRIBUTE_DIRECTORY	1
	#define	FILE_ATTRIBUTE_ARCHIVE		2
	#define	FILE_ATTRIBUTE_SYSTEM		4
	#define	FILE_ATTRIBUTE_HIDDEN		8
	#define	FILE_ATTRIBUTE_READONLY		16

#else
	typedef	void*		FHND;
#endif



/// t@CV[N@.
enum EnFILE_SEEK
{
#if defined( PLATFORM_WIN32 )
	enFILE_BEGIN	= FILE_BEGIN,	///< 
	enFILE_CURRENT	= FILE_CURRENT,	///< ݈ʒu
	enFILE_END		= FILE_END,		///< I[
#else
	enFILE_BEGIN	= SCE_SEEK_SET,	///< 
	enFILE_CURRENT	= SCE_SEEK_CUR,	///< ݈ʒu
	enFILE_END		= SCE_SEEK_END,	///< I[
#endif
};


//		t@C\
struct	FIND_DATA
{
	UInt32	dwFileAttributes;
	UInt32	nFileSize;
	TCHAR	cFileName[ 256 ];
};


/// t.
typedef struct _T_FILETIME
{
	UInt16	m_uYear;
	UInt8	m_uMonth;
	UInt8	m_uDayOfWeek;

	UInt8	m_uDay;
	UInt8	m_uHour;
	UInt8	m_uMinute;
	UInt8	m_uSecond;
} T_FILETIME;


/// t@CI[v.
FHND	FILE_open( LPCTSTR  Filename, const Bool _bNew = FALSE );

//	t@CI[v(݊p)
FHND	FILE_openNew( LPCTSTR  Filename );

/// t@CVK쐬.
FHND	FILE_create( LPCTSTR  Filename );

/// t@CN[Y.
Bool	FILE_close( FHND fd );

/// t@Cf[^ǂݏo.
Bool	FILE_read( FHND _hd, void *_lpBuffer, UInt32 _lBytes, UInt32* _lReadBytes );

/// t@CɃf[^o.
Bool	FILE_write( FHND _hd, void *_lpBuffer, UInt32 _lBytes, UInt32* _lWriteBytes );

/// t@C|C^ړ.
UInt32	FILE_seek( FHND _fd, UInt32 _uLength, EnFILE_SEEK _eMoveMethod );

/// t@CTCY擾.
UInt32	FILE_GetSize( LPCTSTR  _sFilename );
#define	FILE_GetFileSize	FILE_GetSize	///< ݊

/// t@C폜.
Bool	FILE_delete( LPCTSTR  _szName );

/// t@C( First ).
Bool	FILE_finefirst( LPCTSTR  Path, FHND *hd, FIND_DATA *Ff );

/// t@C( Next ).
Bool	FILE_finenext( FHND hd, FIND_DATA *Ff );

/// t@C( Close ).
Bool	FILE_fineclose( FHND hd );

/// fBNg.
Bool	FILE_CreateDirectory( LPCTSTR  szPathName );

/// fBNg폜܂.
Bool 	FILE_RemoveDirectory( LPCTSTR  lpszDir );


/// JgfBNgړ
Bool	FILE_SetCurrentDirectory( LPCTSTR  szPathName );

/// JgfBNg擾
UInt32	FILE_GetCurrentDirectory( LPTSTR  _pBuff, const UInt32 _iSize = 0 );

/// W[(svO)̂pX𓾂
UInt32	FILE_GetModuleDirectory( LPTSTR _pBuff, const UInt32 _iSize = 0 );

/// t@CύX
Bool	FILE_rename( LPCTSTR _lpExistingFileName, LPCTSTR _lpNewFileName );


//	ȉ̊֐͏L̊֐gpʃ[`

/// w̃t@Cobt@ɓǂݍ.
UInt32	FILE_TargetRead( LPCTSTR _szFileName, void* _lpBuffer );



/*----------------------------------------------------------
	w̃t@Cobt@菑o

Bool	FILE_TargetWrite(LPCTSTR  szFileName,void* lpBuffer,UInt32 Size);

@
	LPCTSTR 	t@C
	void*		f[^i[obt@
	UInt32		f[^
@߂l
	Bool		TRUE:@FALSE s
----------------------------------------------------------*/
Bool	FILE_TargetWrite( LPCTSTR  szFileName, void* lpBuffer, UInt32 Size );

Bool	FILE_TextWrite( LPCTSTR _szFileName, LPCTSTR _lpBuffer, Bool _bType = FALSE );


Bool	FILE_TargetWriteMerge( LPCTSTR  szFileName, void* lpBuffer, UInt32 Size );
Bool	FILE_TextWriteMerge( LPCTSTR _szFileName,  LPCTSTR _lpBuffer, Bool _bType = FALSE );



/*----------------------------------------------------------
	t@CRs[

UInt32	FILE_copy( LPCTSTR  szSIFileName, LPCTSTR  szDIFileName );

@
	LPCTSTR 		Rs[t@C
	LPCTSTR 		Rs[t@C
@߂l
	UInt32		t@CTCY
----------------------------------------------------------*/
UInt32	FILE_copy( LPCTSTR  szSIFileName, LPCTSTR  szDIFileName );
/*	l

	Rs[̃t@C 0޲ ̏ꍇłRs[
	(Rs[ 0޲ ŃN[Y)

*/

UInt32	FILE_copyATR( LPCTSTR  szSIFileName, LPCTSTR  szFileName, UInt32 atr );
UInt32	FILE_copyS( LPCTSTR  szSIFileName, LPCTSTR  szFileName, UInt32 atr );


/// t@CɓtZbg.
Bool	FILE_SetTime( LPCTSTR _sFileName, T_FILETIME const *_pFTime );
/// t@C̓t擾.
Bool	FILE_GetTime( LPCTSTR _sFileName, T_FILETIME *_pFTime );

/// t@C̑擾.
Int32	FILE_GetAttributes( LPCTSTR _szFileName );

/// t@C̑Zbg.
void	FILE_SetAttrbites( LPCTSTR  szSIFileName, LPCTSTR  szFileName, UInt32 atr );


/*----------------------------------------------------------
	KwfBNg

Bool	FILE_MakeDirectory( char* lpDi );

@
	char*			tpXt@C
@߂l
	Bool			TRUE:@FALSE s
----------------------------------------------------------*/
Bool	FILE_MakeDirectory( LPCTSTR lpDi );
/*	l
	w肵Kw܂ł̃fBNg쐬
	
	
		݂̃fBNg
			C:\test
	
	FILE_MakeDirectory( "C:\\test\\sample\\123\\program.exe" );
	
		쐬ꂽfBNg
			C:\test\sample\123\
	
	t@C܂Ŏw肳ĂĂ
*/


/*----------------------------------------------------------
	w肵fBNgƃt@C܂B

Bool	FILE_deleteDIR( LPCTSTR  szPathSi );

@
	LPCTSTR  	fBNgi΃pXŎw肵ĉj
@߂l
	Bool		TRUE:@FALSE s
----------------------------------------------------------*/
Bool	FILE_deleteDIR( LPCTSTR  szPathSi );


/*--------------------------------------------------------------------------
	hCut@C

Bool	FILE_search( char* lpRef, char* lpFindFile, char* lpGetPath );


		char*	fBNg
				"\"uJgfBNgv
				"*"uׂẴhCuv
		char*	t@CB
		char*	fBNgi[Bi߂pj

߂l
		TRUE: FALSE:Ȃ
--------------------------------------------------------------------------*/
Bool	FILE_search( char* lpRef, char* lpFindFile, char* lpGetPath );


/*--------------------------------------------------------------------------
	hCũ^Cv𒲂ׂ

int		FILE_getdrive(char cDrive);


	char	hCu̕ i'a'A'b'Ƃj

߂l
	int		0	hCu̎ނfł܂B
			1	[g fBNg݂܂B
			2	hCufBXN𔲂Ƃł܂B
			3	hCufBXN𔲂Ƃł܂B
			4	hCu̓[g (lbg[N) łB
			5	hCuCD-ROMhCułB
			6	hCuRAMfBXNłB
--------------------------------------------------------------------------*/
int		FILE_getdrive( char cDrive );


#if 0
/*--------------------------------------------------------------------------
	fBXNhCuɃfBXNĂȂĂAG[_CAO
	\ȂB

void	FILE_int24(int sw);


		int		0:OFF	1:ON

߂l
		void
--------------------------------------------------------------------------*/
void	FILE_int24( int sw );
#endif




Bool	FILE_stream( LPCTSTR  szName, LPCTSTR  str );
Bool	FILE_printf( LPCTSTR szName, LPCTSTR format,... );


void	FILE_split( LPCTSTR _szPath, LPTSTR _pDrive, LPTSTR _pDirt = NULL, LPTSTR _pFilet = NULL, LPTSTR _pExt = NULL );
void	FILE_merge( LPTSTR _szPath, LPCTSTR _pDrive, LPCTSTR _pDirt = NULL, LPCTSTR _pFilet = NULL, LPCTSTR _pExtt = NULL );



/// t@CXVĂ邩`FbN
Bool	FILE_CheckUpdate( LPCTSTR _sFileName1, LPCTSTR _sFileName2 );

#endif	// _INCLUDE_FILES_H_
// @edulcni files\files.h
// @include files\xcopy.h
//********************************************************************************************
/**
 * @file		xcopy.h
 * @brief		t@C^fBNg XgǗ.
 *
 *	t@Cw肷邱ƂŊYt@CăXg
 *	TufBNgAChJ[h܂ރt@Cw肷鎖\
 *	CfbNX瓾pXAt@C擾ł
 *	
 *	ł̓pXAt@CƂʂŃXgāAt@CɃpXCfbNX܂ł
 *
	X^_[hȗp@
	{
		FILE_XCOPY		cXcopy;
		
		cXcopy.SetSearchSubDir( TRUE );
		cXcopy.AddXcopy( "*.txt" );
		
		printf("entry: %d\r\n", cXcopy.GetEntry() );
		
		for(Int32 ii=0 ; ii<(Int32)cXcopy.GetEntry() ; ii++)
			printf("	%s\r\n", cXcopy.GetPathFileName( ii ) );
	}
 
 * @date		2008/06/07
 * @author		N.Takeda
 */
//********************************************************************************************

#ifndef _INCLUDE_XCOPY_H_ /* d`h~ */
#define _INCLUDE_XCOPY_H_ /* d`h~}N */

#include <stdio.h>
#include <string>
#include <vector>


/// UNICODE ɑΉeXg 2008/11/07
#ifndef	__XSTRING__
	#ifdef	_UNICODE
		typedef	std::wstring	xstring;
	#else
		typedef	std::string		xstring;
	#endif
	#define	__XSTRING__
#endif


/**
	t@C\.
*/
struct	FILE_INFO
{
	xstring		sName;			///< t@C(pX͊܂܂Ȃ).
	Int32		iPathIdx;		///< pXe[ũCfbNX.
};


typedef	std::vector< FILE_INFO >	LFileInfo;
typedef	std::vector< xstring >		VPaths;


//------------------------------------------------------------------
/**
	t@C^fBNgXgǗNX.
*/
//------------------------------------------------------------------
class	FILE_XCOPY
{
public:
	FILE_XCOPY();
	~FILE_XCOPY();
	
	/// XgNA.
	void	Clear();
	/// Xgvf폜.
	Bool	Delete( const UInt32 _iIdx );
	Bool	Delete( const LFileInfo::iterator _ite );
	/// Xgwgq폜.
	Int32	DeleteOnExt( LPCTSTR _pExt, Bool _bRevFlag );
	
	/// Xg擾.
	UInt32	GetEntry() const
	{
		Int32	cc = m_lFiles.size();
		return (UInt32)m_lFiles.size();
	}
	
	
	/// pX+t@C擾.
	xstring	GetStringPathFileName( const UInt32 _iIdx );
	/// t@C擾.
	xstring	GetStringFileName( const UInt32 _iIdx );
	xstring	GetStringFileName( const LFileInfo::iterator _ite );
	/// gq擾.
	xstring	GetStringFileExt( const UInt32 _iIdx );
	xstring	GetStringFileExt( const LFileInfo::iterator _ite );
	
	/// pX擾.
	xstring	GetStringPath( const UInt32 _iIdx );
	
	
	/// char*Ԃ߂̌݊p
	/// pX+t@C擾.
	inline	LPCTSTR	GetPathFileName( const UInt32 _iIdx ){
		lstrcpy( m_sWork, GetStringPathFileName( _iIdx ).c_str() );
		return m_sWork;
	}
	/// t@C擾.
	inline	LPCTSTR	GetFileName( const UInt32 _iIdx ){
		lstrcpy( m_sWork, GetStringFileName( _iIdx ).c_str() );
		return m_sWork;
	}
	inline	LPCTSTR	GetFileName( const LFileInfo::iterator _ite ){
		lstrcpy( m_sWork, GetStringFileName( _ite ).c_str() );
		return m_sWork;
	}
	/// gq擾.
	inline	LPCTSTR	GetFileExt( const UInt32 _iIdx ){
		lstrcpy( m_sWork, GetStringFileExt( _iIdx ).c_str() );
		return m_sWork;
	}
	inline	LPCTSTR	GetFileExt( const LFileInfo::iterator _ite ){
		lstrcpy( m_sWork, GetStringFileExt( _ite ).c_str() );
		return m_sWork;
	}

	/// pX擾.
	inline	LPCTSTR	GetPath( const UInt32 _iIdx ){
		lstrcpy( m_sWork, GetStringPath( _iIdx ).c_str() );
		return m_sWork;
	}
	
	
	/// TutH_tOZbg.
	void	SetSearchSubDir( Bool _bFlag ){	m_bSearchSubDir = _bFlag;	}
	/// TutH_tO擾.
	Bool	GetSearchSubDir() const{		return m_bSearchSubDir;		}
	
	/// fBNg\擾(ǉ).
	Bool	AddXcopy( LPCTSTR _pFileName );
	
	/// XVp֐Zbg.
	void	SetUpdateFunc( Bool (*_pFunc)( void* ), void *_pParam, const Int32 _iCount );
	
private:
	/// t@C^fBNgXg擾.
	void	getDirctoryTree( LPCTSTR _pPath, Bool _bSubDir );
	
	/// t@C\邽ߌ̃fBNgTu֐.
	void	subCheckDir( LPCTSTR _pPath, FIND_DATA _Find_Data, Bool _bSubDir );
	Bool	subCheckFile( LPCTSTR _pPath, FIND_DATA _Find_Data );
	
	/// pXe[uoX̃CfbNX擾.
	UInt64	getPathIdx( LPCTSTR _pPath );
	
	
	
	/// pXe[u.
	VPaths		m_sPaths;
	/// t@Ce[u.
	LFileInfo	m_lFiles;
	
	/// TutH_tO.
	Bool		m_bSearchSubDir;
	
	/// char*Ԃ߂̌݊p
	TCHAR		m_sWork[1024];
	
	/**
	 * XV.
	 *	tH_̃t@C鎞AI܂ŏԂĂȂ̂ł̊Ԃ̉ʍXVɗp.
	 */
	Bool		(*m_pFunc)( void *_pParam );		///< XV֐|C^.
	void		*m_pParam;							///< p[^.
	Int32		m_iCallCount;						///< ĂяoԊuJE^.
	Int32		m_iCallMax;							///< ĂяoԊu(t@C1鏈1JEg).
	
};


#endif	// _INCLUDE_XCOPY_H_
// @edulcni files\xcopy.h
#endif	// PLATFORM_WIN32

// @include memory\memory.h
//********************************************************************************************
/**
 * @file		memory.h
 * @brief		֘A
	
		̃t@C̏ڍא
 * 
 * @author		N.Takeda
 * @date		2010/12/20() 17:50:54
 */
//********************************************************************************************

#ifndef	_MEMORY_H_	// d`h~
#define	_MEMORY_H_	// d`h~}N


#if 1	// o[W݊p.
/*----------------------------------------------------------
	w肵TCỸmہA\̂ɏԂ

Bool	MEM_alloc(char **mem,UINT Attr,UInt32 Size);

@
	char**		\̂|C^
	UINT		
	UInt32		mۂ郁TCY
@߂l
	Bool		TRUE:@FALSE s
----------------------------------------------------------*/
Bool	MEM_alloc(char **ptr,UInt32 size);
Bool	MEM_alloc(long **ptr,UInt32 size);
Bool	MEM_alloc(short **ptr,UInt32 size);
Bool	MEM_alloc(UInt16 **ptr,UInt32 size);
Bool	MEM_alloc(UInt32 **ptr,UInt32 size);


/*----------------------------------------------------------
	mۂ̈J@݊̂߂ɒuĂAʏMEM_del()}Ng

Bool	MEM_free(char **mem);

@
	char**		\̂|C^
@߂l
	Bool		TRUE:@FALSE s
----------------------------------------------------------*/
Bool	MEM_free(char **ptr);
Bool	MEM_free(short **ptr);
Bool	MEM_free(UInt16 **ptr);
Bool	MEM_free(long **ptr);
Bool	MEM_free(UInt32 **ptr);

#define	mem_del(p)	del_alloc(p)	///< ݊p.
#endif


#define	mem_alloc(type,ptr,size)	\
		del_alloc(ptr);\
		ptr = tnew(eMEM_nothing) type[ size ];

#define	del_alloc(p)	{if((p)!=NULL){delete [] (p);(p)=NULL;}}

//_~[ǉ
#define	mem_new(type,ptr)	\
		del_new(ptr);\
		ptr = tnew(eMEM_nothing) type;
//		memset((char*)ptr,0,size*sizeof(type) );

#define	del_new(p)	{if((p)!=NULL){delete (p);(p)=NULL;}}


/// rbg^Cv.
enum EnBitCtrl
{
	enBitCtrlRead = -1,
	enBitCtrlSet0,
	enBitCtrlSet1,
};


/// 32bitobt@f[^̃rbg
Int32	bitcontrol32( UInt32 *_pBuff, const Int32 _iMax, const Int32 _iNum, const EnBitCtrl _iMode );
/// 16bitobt@f[^̃rbg
Int32	bitcontrol16( UInt16 *_pBuff, const Int32 _iMax, const Int32 _iNum, const EnBitCtrl _iMode );
/// 8bitobt@f[^̃rbg
Int32	bitcontrol8(  UInt8  *_pBuff, const Int32 _iMax, const Int32 _iNum, const EnBitCtrl _iMode );




/*----------------------------------------------------------
	mۂAwt@Cǂݍ
----------------------------------------------------------*/
UInt32	MEM_TargetRead( char **ptr, LPCTSTR name );
UInt32	MEM_TargetRead( char **ptr, LPCTSTR name, UInt32 len);
UInt32	MEM_TargetRead( char **ptr, LPCTSTR name, UInt32 offset, UInt32 len );

UInt32	MEM_TargetRead2( char **_pPtr, LPCTSTR _pName, const Int32 _iMul );
UInt32	MEM_TextRead( TCHAR **_pPtr, LPCTSTR _pName );
UInt32	MEM_TextRead2( TCHAR **_pPtr, LPCTSTR _pName, const Int32 _iMul );


/*----------------------------------------------------------
	Ԃ̃Rs[

void	MEM_copy(char* memD,char* memS,UInt32 Length);

@
	char*		Rs[惁\
	char*		Rs[\
	UInt32		Rs[TCY
@߂l
	Ȃ
----------------------------------------------------------*/
void	MEM_copy( void *_memD, const void *_memS, UInt32 _uLength );


/*----------------------------------------------------------
	Ԃ̈ړ

void	MEM_move(char* memD,char* memS,UInt32 Length);

@
	char*		Rs[惁\
	char*		Rs[\
	UInt32		Rs[TCY
@߂l
	Ȃ
----------------------------------------------------------*/
void	MEM_move( void *_memD, const void *_memS, UInt32 _uLength );


#if 0//old ver
#ifdef _STRING_H_
/// ̒ɍ킹ămۂRs[
Int32	MEM_STRING_cpy( LPTSTR *_pMem, LPCTSTR _pString );
#endif
#endif



#endif // _MEMORY_H_ d`h~
// @edulcni memory\memory.h

// @include string\toSjis.h
#ifndef	_TOSJIS_H_
#define	_TOSJIS_H_

#if defined( PLATFORM_WIN32 )
//********************************************************************************************
/**
 * @brief		ႿSJIS𓾂NX.
 *				CTOSJIS	cJis;				//錾
 *				cJis.From(L"");	//OKB߂lSJIS
 *				strlen( cJis.get() );		//ȍ~get()œ
 *
 *				܂
 *
 *				CTOSJIS	cJis("");	//錾
 *				strlen( cJis.Get() );		//ȍ~get()œ
 *
 * @date		2008/10/21() 17:00:23
 * @author		N.Takeda
 */
//********************************************************************************************
class CTOSJIS
{
private:
	/// ϊ㕶ۊǗp.
	char*	m_sString;
	
public:
	char* From( LPCWSTR sUniStr )
	{
		if( m_sString != NULL)	delete [] m_sString;
		
		/// TCY(\0܂ł).
		const Int32 nSize = WideCharToMultiByte( CP_ACP, 0, sUniStr, -1, NULL, 0, NULL, NULL );
		
		/// ̈m.
		m_sString = tnew(eMEM_nothing) char[ nSize ];
		
		/// ϊ.
		WideCharToMultiByte( CP_ACP, 0, sUniStr, -1, m_sString, nSize, NULL, NULL );
		m_sString[ nSize-1 ] = 0;
		
		return m_sString;
	}
	char* Get(){	return m_sString;	}
	
	CTOSJIS()
	: m_sString( NULL )
	{}
	CTOSJIS( LPCWSTR sUniStr )
	: m_sString( NULL )
	{
		if( !sUniStr )	From( sUniStr );
	}
	~CTOSJIS()
	{
		if( m_sString != NULL )	delete [] m_sString;
	}
};
#else

class CTOSJIS
{
private:
public:
	char* From( LPCWSTR )
	{
		return NULL;
	}
	char* Get(){	return NULL;	}
	
	CTOSJIS()
	{}
	CTOSJIS( LPCWSTR  )
	{
	}
	~CTOSJIS()
	{
	}
};

#endif

#endif	// _TOSJIS_H_
// @edulcni string\toSjis.h
// @include string\toUTF16.h
#ifndef	_TOUTF16_H_
#define	_TOUTF16_H_

#if defined( PLATFORM_WIN32 )
//********************************************************************************************
/**
 * @brief		ႿUTF16𓾂NX.
 *
 *				CTOUTF16	cUtf;			//錾
 *				cUtf.From("");	//OKB߂lUTF16
 *				strlen( cUtf.Get() );		//ȍ~get()œ
 *
 *				܂
 *
 *				CTOUTF16	cUtf("");	//錾
 *				strlen( cUtf.Get() );			//ȍ~get()œ
 *
 * @date		2008/10/21() 17:00:23
 * @author		N.Takeda
 */
//********************************************************************************************
class CTOUTF16
{
private:
	/// ϊ㕶ۊǗp.
	WCHAR*	m_sString;
	
public:
	WCHAR* From( const char *_sSjisStr )
	{
		if( m_sString != NULL)	delete [] m_sString;
		
		/// TCY.
		const Int32 nSize = MultiByteToWideChar( CP_ACP, 0, _sSjisStr, -1, NULL, 0 );
		
		/// ̈m.
		m_sString = tnew(eMEM_nothing) WCHAR[ nSize+1 ];
		
		/// ϊ.
		MultiByteToWideChar( CP_ACP, 0, _sSjisStr, -1, m_sString, nSize );
		m_sString[ nSize ] = 0;	///< -1̕Kv邩Ȃ
		
		return m_sString;
	}
	WCHAR* Get(){	return m_sString;	}
	
	CTOUTF16()
	: m_sString( NULL )
	{}
	CTOUTF16( const char *_sSjisStr )
	: m_sString( NULL )
	{
		if( !_sSjisStr )	From( _sSjisStr );
	}
	~CTOUTF16()
	{
		if( m_sString != NULL )	delete [] m_sString;
	}
};
#else

class CTOUTF16
{
private:
public:
	WCHAR* From( const char * )
	{
		return NULL;
	}
	WCHAR* Get(){	return NULL;	}
	
	CTOUTF16()
	{}
	CTOUTF16( const char * )
	{
	}
	~CTOUTF16()
	{
	}
};

#endif

#endif	// _TOUTF16_H_
// @edulcni string\toUTF16.h
// @include string\string.h
//********************************************************************************************
/**
 * @file		string.h
 * @brief		v
 *
 *	̃t@C̏ڍא
 *
 * @author		N.Takeda
 * @date		2009/06/30() 14:50:06
 */
//********************************************************************************************

#ifndef __STRING_H__ /* d`h~ */
#define __STRING_H__ /* d`h~}N */

#ifndef	_STOOLS_H
#include "..\types.h"
#include "toSjis.h"
#include "toUTF16.h"
#endif

#if !defined( _UNICODE ) && defined( PLATFORM_WIN32 )
#include <mbctype.h>
#include <mbstring.h>
#endif

/// Pꔻ莞AEƂȂ镶Xg̃ftHgl(\0͎w肵ĂȂĂ肳As͕₷邽߂ɋLqĂ)
#define		DEFAULT_BORDERCHAR	TEXT(" \t\r\n\0")


//======================================================================================
//		XgO֘A
//======================================================================================

/// Rs[֐.
Bool	STRING_cpy( LPTSTR _sBuffD, LPCTSTR _sBuffS, const Int32 _iLength = 0 );

/// ǉ֐.
Bool	STRING_cat( LPTSTR _sBuffD, LPCTSTR _sBuffS, const Int32 _iLength = 0 );

/// Ɖ֐.
Int32	STRING_cmp( LPCTSTR _sStr1, LPCTSTR _sStr2 );
Int32	STRING_cmp2( LPCTSTR _sStr1, LPCTSTR _sStr2 );

/// ̒Ԃ.
Int32	STRING_len( LPCTSTR _sStr );


/// obt@ƕƍ.
Bool	STRING_buffcmp( LPCTSTR _sStr1, LPCTSTR _sStr2, LPCTSTR _pCharList = DEFAULT_BORDERCHAR );
Bool	STRING_buffcmp2( LPCTSTR _sStr1, LPCTSTR _sStr2, LPCTSTR _pCharList = DEFAULT_BORDERCHAR );

/// obt@̒P̒𓾂.
Int32	STRING_bufflen( LPCTSTR _pBuff, LPCTSTR _pCharList = NULL );

//********************************************************************************************
/**
 * @brief		 \ ȂΒǉ
 * @author		N.Takeda
 * @date		2009/06/30() 18:56:41
 *
 * @param[in,out]	LPTSTR	_sStr	
 *
 * @return		Ȃ (none)
 */
//********************************************************************************************
inline	void	catyen( LPTSTR _sStr )
{
	if( _sStr[ STRING_len( _sStr ) - 1 ] != '\\' )	STRING_cat( _sStr, TEXT("\\") );
}

//********************************************************************************************
/**
 * @brief		 \ 폜
 * @author		N.Takeda
 * @date		2009/06/30() 18:58:05
 *
 * @param[in,out]	LPTSTR	_sStr	
 *
 * @return		Ȃ (none)
 */
//********************************************************************************************
inline	void	cutyen( LPTSTR _sStr )
{
	if( _sStr[ STRING_len( _sStr )-1 ] == '\\' )	_sStr[ STRING_len( _sStr ) - 1 ] = 0;
}


//********************************************************************************************
/**
 * @brief		ɉsȂΒǉ(s\n)
 * @author		N.Takeda
 * @date		2009/08/10() 22:47:29
 *
 * @param[in,out]	LPTSTR	_sStr	
 *
 * @return		Ȃ (none)
 */
//********************************************************************************************
inline	void	catret( LPTSTR _sStr )
{
	if( _sStr[ STRING_len( _sStr ) - 1 ] != '\n' )	STRING_cat( _sStr, TEXT("\n") );
}

//********************************************************************************************
/**
 * @brief		̉s폜(s\n)
 * @author		N.Takeda
 * @date		2009/08/10() 22:47:19
 * @date		2010/03/24() 14:08:59	N.Takeda	\rǉĂ݂
 *
 * @param[in,out]	LPTSTR	_sStr	
 *
 * @return		Ȃ (none)
 */
//********************************************************************************************
inline	void	cutret( LPTSTR _sStr )
{
	if( _sStr[ STRING_len( _sStr )-1 ] == '\n' )	_sStr[ STRING_len( _sStr )-1 ] = 0;
	if( _sStr[ STRING_len( _sStr )-1 ] == '\r' )	_sStr[ STRING_len( _sStr )-1 ] = 0;
}


/// obt@當
LPTSTR	STRING_str( LPCTSTR _sBuff, LPCTSTR _sStr, const Int32 _iLength = 0, LPCTSTR _pCharList = NULL );
LPTSTR	STRING_str2( LPCTSTR _sBuff, LPCTSTR _sStr, const Int32 _iLength = 0, LPCTSTR _pCharList = NULL );


/// w肵Xgɑ݂邩ׂ
Int32	STRING_CheckChar( const TCHAR _cChar, LPCTSTR _sCharList );
/// w肵Xgɑ݂邩ׂ(ەԂVer)
inline	Bool	string_CheckChar( const TCHAR _cChar, LPCTSTR _pCharList );


/// |C^ʒu̒P̐擪ֈړ
LPTSTR	STRING_word( LPCTSTR _pBuff, LPCTSTR _pBuffMin, LPCTSTR _pCharList = DEFAULT_BORDERCHAR );

/// PO̒Pփ|C^ړ
LPTSTR	STRING_backWord( LPCTSTR _pBuff, LPCTSTR _pBuffMin, LPCTSTR _pCharList = DEFAULT_BORDERCHAR );

/// ̒Pփ|C^ړ
LPTSTR	STRING_nextWord( LPCTSTR _pBuff, LPCTSTR _pCharList = DEFAULT_BORDERCHAR );

/// Xy[XA^ułȂȂ܂Ń|C^i߂(s͌Ȃ)
LPTSTR	STRING_skipSpace( LPCTSTR _pBuff, const Int32 _iLength = 0 );

/// w蕶܂Ń|C^i߂
LPTSTR	STRING_searchChar( LPCTSTR _pBuff, const TCHAR _cCh, const Int32 _iLength = 0 );

/// obt@P؂o
Int32	STRING_getWord( LPCTSTR _pBuff, LPTSTR _pWork, LPCTSTR _pCharList = DEFAULT_BORDERCHAR );

/// w|C^ʒu̍s؂o(s܂܂Ȃ)
Int32	STRING_getLine( LPCTSTR _pBuff, LPCTSTR _pBuffMin = NULL, LPTSTR _pWork = NULL );


/// p啶ɂ
LPTSTR	STRING_ToBig( LPTSTR _pString );

/// pɂ
LPTSTR	STRING_ToSmall( LPTSTR _pString );


//********************************************************************************************
/**
 * @brief		At@xbg啶Ȃ珬ɕϊ
 * @author		N.Takeda
 * @date		2009/08/26() 18:29:20
 *
 * @param[in]	const TCHAR	_ch	
 *
 * @return		TCHAR	ϊ̕
 */
//********************************************************************************************
inline	TCHAR	_KMOJI( const TCHAR _ch )
{
	return ( _ch >= 'A' && _ch <= 'Z' ) ? _ch + ('a'-'A') : _ch;
}
//********************************************************************************************
/**
 * @brief		At@xbgȂ啶ɕϊ
 * @author		N.Takeda
 * @date		2009/08/26() 18:29:18
 *
 * @param[in]	const TCHAR	_ch	
 *
 * @return		TCHAR	ϊ̕
 */
//********************************************************************************************
inline	TCHAR	_OMOJI( const TCHAR _ch )
{
	return ( _ch >= 'a' && _ch <= 'z' ) ? _ch - ('a'-'A') : _ch;
}


//********************************************************************************************
/**
 * @brief		w|C^̕pJiǂ𓾂
 * @author		N.Takeda
 * @date		2009/08/17() 20:15:43
 *
 * @param[in]	TCHAR	_cMoji	
 *
* @return		Bool	TRUE: / FALSE:
 */
//********************************************************************************************
inline	Bool	STRING_IsKana( TCHAR _cMoji )
{
#if !defined( _UNICODE ) && defined( PLATFORM_WIN32 )
	return ( _ismbbkana(_cMoji) != 0 );
#else
	return ( _cMoji >= 0xff61 && _cMoji <= 0xff9f );
#endif
}

//********************************************************************************************
/**
 * @brief		Sp(}`oCg)ǂ𓾂(擪oCĝ݂̔)
 * @author		N.Takeda
 * @date		2009/08/17() 17:24:20
 *
 * @param[in]	TCHAR	_cMoji	|C^
 *
* @return		Bool	TRUE: / FALSE:
 */
//********************************************************************************************
inline	Bool	STRING_IsMultiByte( TCHAR _cMoji )
{
#if !defined( _UNICODE ) && defined( PLATFORM_WIN32 )
	return ( _ismbblead(_cMoji) != 0 );
#else
	return ( _cMoji > 0x7d && _cMoji != 0x203e && _cMoji < 0xff61 );
#endif
}

//********************************************************************************************
/**
 * @brief		w|C^̕Sp(}`oCg)ǂ𓾂
 * @author		N.Takeda
 * @date		2011/03/30() 11:48:55
 *
 * @param[in]	LPCTSTR	_pMoji	|C^.
 *
* @return		Bool	TRUE: / FALSE:
 */
//********************************************************************************************
inline	Bool	STRING_IsMultiByte( LPCTSTR _pMoji )
{
#if !defined( _UNICODE ) && defined( PLATFORM_WIN32 )
	return ( _ismbblead(*_pMoji) != 0 && _ismbbtrail(*(_pMoji+1)) );
#else
	return ( *_pMoji > 0x7d && *_pMoji != 0x203e && *_pMoji < 0xff61 );	//UNICODĚ㑱oCg͖
#endif
}

//********************************************************************************************
/**
 * @brief		}`oCg̒𓾂(unicode1AȊO2Ԃ)
 *				Ƀ}`oCgAunicode݊̃R[ĥɎg
 * @author		N.Takeda
 * @date		2009/08/17() 17:36:00
 *
 * @param[in]	LPCTSTR	_pPtr	|C^
 *
 * @return		Int32	
 */
//********************************************************************************************
inline	Int32	STRING_GetMultiByte()
{
#ifndef	_UNICODE
	return 2;
#else
	return 1;
#endif
}

inline	Bool	STRING_IsCgGraph( TCHAR _cMoji )
{
#if !defined( _UNICODE ) && defined( PLATFORM_WIN32 )
	return (_ismbcgraph(_cMoji) != 0 );	///< pAt@xbg
#else
	return (_cMoji > 0x20 && _cMoji <= 0x7d );
#endif
}

/// 𐔒lɕϊ("0x"PUiƔf)
Int32	STRING_atoi( LPCTSTR _pStr );

/// 𕂓_lɕϊ
Float32	STRING_atof( LPCTSTR _pStr );

///	_ϐ𕶎ɕϊ.
void	STRING_ftoa( LPTSTR str, float value );


/// STRING_dirctoryUp֐
Bool	STRING_dirctoryUp( LPTSTR _pWork );

/// pXw蕶Ɋ܂܂ ".." 𐮗
Int32	STRING_TidyDirctory( LPTSTR path );

/// printf֐.
Int32	STRING_printf( LPTSTR _pBuff, const Int32 _iBuffSize, LPCTSTR _pFormat, ... );

#if 0
/*----------------------------------------------------------
	obt@ƕƍ(I[mFĂ)

Bool	STRING_cmp(char *Sbuff,char *string);

@
	const char*		
	const char*		
@߂l
	Bool		
----------------------------------------------------------*/
Bool	STRING_cmp(char *Sbuff,char *string);



/*----------------------------------------------------------
	obt@ƕƍ()

Bool	STRING_str(char *Sbuff,char *string);

@
	const char*		
	const char*		
@߂l
	Bool		
----------------------------------------------------------*/
Bool	STRING_str(LPTSTR Sbuff,LPTSTR string);



/*----------------------------------------------------------
	obt@ƕƍ(oI[mFĂ)

char	*STRING_search(char *Sbuff,char *string,UInt32 *Length);

@
	const char*		
	const char*		
@߂l
	Bool		
----------------------------------------------------------*/
//char	*STRING_search(char *Sbuff,char *string,UInt32 *Length);



/*----------------------------------------------------------
	obt@當

char	*STRING_search(char *Sbuff,char *string,UInt32 *Length);

@
	const char*		obt@i[|C^
	const char*		镶
	UInt32*		̈̒
@߂l
	const char*		obt@̃|C^
----------------------------------------------------------*/
LPTSTR	STRING_search(char *Sbuff,char *string,UInt32 *Length);
/*	l
Lengthɂ͔|C^f[^Gh܂ł̒Ԃ

ȂꍇNULLԂ
*/



/*----------------------------------------------------------
	obt@當  ͖

char	*STRING_searchCOM(char *Sbuff,char *string,UInt32 *Length,char COM);

@
	const char*		obt@i[|C^
	const char*		镶
	UInt32*		钷
	char		
@߂l
	const char*		obt@̃|C^
----------------------------------------------------------*/
char	*STRING_searchCOM(char *Sbuff,char *string,UInt32 *Length,char COM);
/*	l
Lengthɂ͔|C^f[^Gh܂ł̒Ԃ

ȂꍇNULLԂ
*/



/*----------------------------------------------------------
	obt@當؂o
		󔒂܂ރRg[R[hP̏I[Ƃ݂Ȃ

Int32		STRING_getword(unsigned char *Buffer,char* str);

@
	const char*		
	char*		
@߂l
	ړ Buffer |C^
----------------------------------------------------------*/
Int32		STRING_getword(unsigned char *Buffer,char* str);



/*----------------------------------------------------------
	obt@當؂o
		󔒂܂ރRg[R[hAJ}ARP̏I[Ƃ݂Ȃ

Int32		STRING_getwordSec(unsigned char *Buffer,char* str,unsigned char *ch,char defstr);

@
	const char*		
	char*		
	char*		
@߂l
	ړ Buffer |C^(񒷂łȂƂɒ)
----------------------------------------------------------*/
Int32		STRING_getwordSec(unsigned char *Buffer,char* str,unsigned char *ch,char defstr);



/*----------------------------------------------------------
	obt@|C^𕶎܂Ői߂

char*	STRING_nextchar(unsigned char *Buffer,UInt32 *line);

@
	char*		
	UInt32*		
@߂l
	char*		
----------------------------------------------------------*/
char*	STRING_nextchar(unsigned char *Buffer,UInt32 *line);
/*	l
line ɂ̓XLbvɔ^[R[h̐Ԃ
*/



/*----------------------------------------------------------
	݈ʒu̒P̎̒PT(J}؂Ɣf)

char*	STRING_skipwordSec(unsigned char *Buffer,UInt32 *line);

@
	char*		
	UInt32*		
@߂l
	char*		
----------------------------------------------------------*/
char*	STRING_skipwordSec(unsigned char *Buffer,UInt32 *line);
/*	l
@߂lɂ͏I[ł,΂炪Ԃ

*/


/*----------------------------------------------------------
	݈ʒu̒P̎̒PT

char*	STRING_skipword(unsigned char *Buffer,UInt32 *line);

@
	char*		
	UInt32*		
@߂l
	char*		
----------------------------------------------------------*/
char*	STRING_skipword(unsigned char *Buffer,UInt32 *line);


/*----------------------------------------------------------
	p[^𒲂ׂ܂

Bool STRING_checkparam( const char* cmdline, char n);

@
	const char*		镶
	char		p[^@啶
@߂l
	Bool		TRUE:܂B@FALSE:܂B
----------------------------------------------------------*/
Bool STRING_checkparam( const char* cmdline, char n);


/*----------------------------------------------------------
	p[^擾

char	*STRING_getparam(char* cmdline,char n,char *string);

@
	const char*		镶
	char		p[^@啶ʁ@0ŃR}hȂ𓾂
	char*		p[^󂯎|C^
@߂l
	char*		|C^̑ Ō܂Ōꍇ NULL Ԃ
----------------------------------------------------------*/
char*	STRING_getparam(char* cmdline,char n,char *string);


char	*STRING_BigToSmall( char *lpCheckStr );
char	*STRING_SmallToBig( char *lpCheckStr );


/*----------------------------------------------------------
		݂̃AhX̕񂪑SpPoCgڂASpQoCgڂA
		pHׂ֐B

Int32		STRING_DoubleMoji( unsigned char* Text, Int32 nPtr );

@
	unsigned char*		|C^
  ߂l
		0:	p
		1:	SpPoCg
		2:	SpQoCg
----------------------------------------------------------*/
Int32		STRING_DoubleMoji( unsigned char *lpStr);
Int32		STRING_DoubleMoji(const unsigned char *lpStr,Int32 adr);

Bool	STIRNG_ismbcdigit(Int32 c);


void	STRING_insert(Int32 ptr,char* lpStr,Int32 length,char *string,Int32 strlen);

/*------------------------------------------------------
		|C^̎f[^Spǂׂ

Bool	STRING_multiple(char *ptr);

@
	char*		|C^
  ߂l
	Bool		1:Sp@0:ȊO
------------------------------------------------------*/
Bool	STRING_multiple(char *ptr);


void	string_using0(Int32 us,char *str,Int32 value);
#endif

#ifndef _UNICODE

#define MOJI_KIND_JIS	0
#define MOJI_KIND_EUC	1

//		ShiftJIS  JIS ܂ EUC ɕϊ
Int32	STRING_SjisTo(unsigned long code,Int32 kind);

Int32		STRING_middle(char *string,char *str);
Int32		STRING_middle2(char *string,char *str);
Int32		STRING_middle( char *string,char st );
#endif

#endif	//__STRING_H__
// @edulcni string\string.h
// @include string\Probuff.h
//********************************************************************************************
/**
 * @file		Probuff.h
 * @brief		v
	
		̃t@C̏ڍא
 * 
 * @author		N.Takeda
 * @date		2010/10/21() 18:14:12
 */
//********************************************************************************************

#ifndef	___INCLUDE_MHI_System_privatePROBUFF__H___	// d`h~
#define	___INCLUDE_MHI_System_privatePROBUFF__H___	// d`h~}N


#if 1//ndef _MASTER

/// ZNV݂邩ǂ𓾂.
Bool	PROBUFF_IsSection( const TCHAR *const _pBuff, const Int32 _iBuffLength, const TCHAR *const _pSec );

/// ݒt@C當擾.
Int32	PROBUFF_GetString( LPCTSTR _pBuff, const Int32 _iLength, const TCHAR *const _pSec, const TCHAR *const _pKey, TCHAR *_pString, const Int32 _iStringLength, const TCHAR *const _pDefStr = NULL );
/// ݒt@C琔l擾(PUi\LΉ).
Int32	PROBUFF_GetInt( LPCTSTR _pBuff, const Int32 _iLength, const TCHAR *const _pSec, const TCHAR *const _pKey, const Int32 _iDefVal = 0 );
/// ݒt@C琔l擾.
Float32	PROBUFF_GetFloat( LPCTSTR _pBuff, const Int32 _iLength, const TCHAR *const _pSec, const TCHAR *const _pKey, const Float32 _fDefVal = 0.f );

template<class TREG> Int32	PROBUFF_ToNumArray( LPCTSTR _pBuff, const Int32 _iLength, const TCHAR *const _pSec, const TCHAR *const _pKey, TREG *_pVals, const Int32 _iSize );

#else	//_MASTER

//! ݒt@C當擾.
inline	Int32	PROBUFF_GetString( TCHAR *_pString, const Int32 _iStringLength, const TCHAR *const , const TCHAR *const , const TCHAR *const _pDefStr = NULL )
{
	strncpy( _pString, _pDefStr, _iStringLength-1 );
	return strlen( _pDefStr );
}

//! ݒt@C琔l擾(PUi\LΉ).
#define	PROBUFF_GetInt( _pSec, _pKey, _iDefVal )								( _fDefVal )
//! ݒt@C琔l擾.
#define	PROBUFF_GetFloat( _pSec, _pKey, _fDefVal )								( _fDefVal )

#endif	//_MASTER


#endif // ___INCLUDE_MHI_System_privatePROBUFF__H___ d`h~

// @edulcni string\Probuff.h
// @include cul.h


/**************************************************************************//**
	@brief		ľZ.
	@author		N.Takeda
	@date		2010/10/19() 21:14:13

	@param[in,out]	T&				_Reg	ϐ.
	@param[in]		const T			_Val	Zl.
	@param[in]		const T _Min	_Min	ŏl(ȗ0).

	@return		l̕ω true
*//***************************************************************************/
template <class T>	T ValSub( T &_Reg, const T _Val, const T _Min = 0 )
{
	const	T	orgReg = _Reg;
	if( _Reg > _Min ){
		_Reg -= _Val;
		if( _Reg < _Min )	_Reg = _Min;
	}
	return (orgReg != _Reg);
}


/**************************************************************************//**
	@brief		l̉Z.
	@author		N.Takeda
	@date		2010/10/19() 21:14:09

	@param[in,out]	T&		_Reg	ϐ.
	@param[in]		const T	_Val	Zl.
	@param[in]		const T	_Max	ől.

	@return		l̕ω true
*//***************************************************************************/
template <class T>	T ValAdd( T &_Reg, const T _Val, const T _Max )
{
	const	T	orgReg = _Reg;
	if( _Reg < _Max ){
		_Reg += _Val;
		if( _Reg >_Max )	_Reg = _Max;
	}
	return (orgReg != _Reg);
}

// @edulcni cul.h

// @include system\ezParam.h
//********************************************************************************************
/**
 * @file		ezParam.h
 * @brief		p[^ǗNX
	
		ɓnꂽ _szCmdLine Ȃǂ̕񂪂
		
		CEzParam	cParam( _szCmdLine );	///< . _szCmdLine const ͓̎ŃRs[ꂽ̂.
		
		
 * 
 * @author		N.Takeda
 * @date		2011/05/30() 22:07:10
 */
//********************************************************************************************

#ifndef	_EZPARAM_H_	/* d`h~ */
#define	_EZPARAM_H_	/* d`h~}N */


//********************************************************************************************
/**
 * @class		CEzParam
 * @brief		
 * @author		N.Takeda
 * @date		2011/05/30() 18:27:59
 */
//********************************************************************************************
class CEzParam
{

protected:
	
	LPTSTR	m_pBuff;								///< obt@.
	LPTSTR	m_pParamString;							///< ^ꂽp[^.
	Int32	m_iParamLength;							///< ^ꂽp[^.

	Int32	m_iEntry;								///< p[^.


	//********************************************************************************************
	/**
	 * @brief		.
	 * @author		N.Takeda
	 * @date		2011/05/30() 21:03:24
	 *
	 * @return		Ȃ (none)
	 */
	//********************************************************************************************
	void	initialize()
	{
		Int32	ii = 0, iStrTop = 0;
		Bool	bInString = FALSE;					///< .
		
		
		/// 擪ɗ]vȃXy[X珜O.
		while( ' ' >= *m_pParamString && 0 < m_iParamLength )
		{
			m_pParamString++;
			m_iParamLength--;
		}
		/// ɗ]vȃXy[X珜.
		while( ' ' >= *(m_pParamString + m_iParamLength - 1 ) && 0 < m_iParamLength )
		{
			m_iParamLength--;
			*(m_pParamString + m_iParamLength) = '\0';
		}
		if( 0 >= m_iParamLength )	return;
		
		
		iStrTop = 0;
		for( ii=0 ; ii<m_iParamLength ; ii++ )
		{
			/// ̓Xy[XA^uL.
			if( '"' == *(m_pParamString + ii ) )	bInString = 1 - bInString;
			
			/// Xy[XA^u؂Ƃĕ.
			if( ('\t' == *(m_pParamString + ii) || ' ' == *(m_pParamString + ii) ) && !bInString )
			{
				Int32	iBottom = ii;
				*(m_pParamString + ii) = '\0';
				
				/// 󔒂ꍇ̓XLbv.
				while( ('\t' == *(m_pParamString + ii+1) || ' ' == *(m_pParamString + ii+1) ) && ii<m_iParamLength )
				{
					ii++;
					*(m_pParamString + ii) = '\0';
				}
				
				deleteDkakko( iStrTop, iBottom );
				iStrTop = ii + 1;
				m_iEntry++;
			}
		}
		
		/// Ō̕܂.
		if( (ii+1) != iStrTop )
		{
			deleteDkakko( iStrTop, ii );
			m_iEntry++;
		}
	}

#if 1
	//********************************************************************************************
	/**
	 * @brief		O " ͍폜.
	 * @author		N.Takeda
	 * @date		2011/05/30() 21:32:50
	 *
	 * @param[in]	const Int32	_iTop		擪"ʒu.
	 * @param[in]	const Int32	_iBottom	"ʒu.
	 *
	 * @return		Ȃ (none)
	 */
	//********************************************************************************************
	void	deleteDkakko( const Int32 _iTop, const Int32 _iBottom )
	{
		/// O " ͍폜.
		if( *(m_pParamString + _iTop) == '\"' && *(m_pParamString + _iBottom - 1) == '\"' )
		{
			*(m_pParamString + _iTop) = '\0';
			*(m_pParamString + _iBottom - 1)  = '\0';
		}
	}
#else
	void	deleteDkakko( const Int32 , const Int32  ){}
#endif

public:
	//********************************************************************************************
	/**
	 * @brief		wCfbNXIvVw肩𓾂.
	 * @author		N.Takeda
	 * @date		2011/06/02() 16:33:29
	 *
	 * @param[in]	const Int32	_iIndex	ԍ.
	 *
	 * @return		Bool	TRUE: / FALSE:
	 */
	//********************************************************************************************
	Bool	IsOption( const Int32 _iIndex )
	{
		LPTSTR	pPtr = GetString( _iIndex );
		if( !pPtr )	return FALSE;
		return ( '-' == *pPtr );
	}
	
	//********************************************************************************************
	/**
	 * @brief		-? IvVw肳ĂȂ炻̃CfbNXԂ.
	 * @author		N.Takeda
	 * @date		2010/08/26() 17:16:14
	 *
	 * @param[in]	const TCHAR	_cOption	IvVL(ȗ-𖳏ɏE).
	 *
	 * @return		Int32	
	 */
	//********************************************************************************************
	Int32	SearchOption( const TCHAR _cOption = 0 )
	{
		TCHAR	sTemp[] = TEXT("- ");
		sTemp[ 1 ] = _cOption;
		
		LPTSTR	pPtr = STRING_str( m_pParamString, sTemp, m_iParamLength );
		if( pPtr )
		{
			Int32	iIdx = 0;
			for( LPTSTR p2=m_pParamString ; p2<pPtr ; p2++ )
			{
				if( '\0' == *(p2) )	iIdx++;
			}
			return iIdx;
		}
		
		return -1;
	}
	
	//********************************************************************************************
	/**
	 * @brief		StringOption̎擾.
	 * @author		N.Takeda
	 * @date		2010/08/26() 20:16:11
	 *
	 * @param[in]	const TCHAR	_cOption	IvVL.
	 * @param[in]	LPCTSTR		_sDef		ftHg(ȗNULL).
	 *
	 * @return		LPTSTR	-? ȍ~̎w蕶
	 */
	//********************************************************************************************
	LPCTSTR	GetStringOption( const TCHAR _cOption, LPCTSTR _sDef = NULL )
	{
		LPTSTR	pPtr;
		
		pPtr = GetString( SearchOption( _cOption ) );
		if( !pPtr )	return _sDef;
		
		return (pPtr + 2);
	}
	
	//********************************************************************************************
	/**
	 * @brief		IntOption̎擾.
	 * @author		N.Takeda
	 * @date		2010/08/26() 20:18:36
	 *
	 * @param[in]	const TCHAR	_cOption	IvVL.
	 * @param[in]	const Int32	_iDef		ftHgl.
	 *
	 * @return		Int32	
	 */
	//********************************************************************************************
	Int32	GetIntOption( const TCHAR _cOption, const Int32 _iDef = -1 )
	{
		LPCTSTR		pPtr = GetStringOption( _cOption );
		if( !pPtr )	return _iDef;
		return STRING_atoi( pPtr );
	}
	
	//********************************************************************************************
	/**
	 * @brief		IvVvf`FbN.
 	 *				-oABC ƂIvVw肳Ă鎞A_cOption'B'w肷trueԂ.
 	 *
	 * @author		N.Takeda
	 * @date		2010/09/02() 15:06:58
	 *
	 * @param[in]	const int	_iIdx		p[^ԍ.
	 * @param[in]	const TCHAR	_cOption	IvV()
	 * @param[in]	const Bool	_bFlag		trueő啶ʂȂ.
	 *
	 * @return		Bool	TRUE: / FALSE:
	 */
	//********************************************************************************************
	Bool	CheckOption( const int _iIdx, const TCHAR _cOption , const Bool _bFlag )
	{
		TCHAR		cOption = _cOption;
		LPCTSTR		pPtr = GetString( _iIdx );
		LPCTSTR		pCh;
		
		if( !pPtr )	return FALSE;
		
		
		if( _bFlag && ('a' <= cOption && cOption <= 'z') )
		{
			/// 啶.
			cOption = cOption - ('a' - 'A');
		}
		
		pCh = STRING_searchChar( pPtr, cOption );
		
		/// "-o"͔̕肵Ȃ.
		if( pCh && 2 <= (pCh-pPtr) )	return TRUE;
		
		return FALSE;
	}

	//********************************************************************************************
	/**
	 * @brief		Entry̎擾.
	 * @author		N.Takeda
	 * @date		2011/05/30() 21:20:46
	 *
	 * @return		Int32	
	 */
	//********************************************************************************************
	Int32	GetEntry() const {	return m_iEntry;	}

	//********************************************************************************************
	/**
	 * @brief		p[^݂邩ǂ̃`FbN.
	 * @author		N.Takeda
	 * @date		2011/05/30() 21:46:57
	 *
	 * @param[in]	const Int32	_iIdx	ԍ.
	 *
	 * @return		Bool	TRUE: / FALSE:
	 */
	//********************************************************************************************
	Bool	IsParam( const Int32 _iIdx )
	{
		if( !m_pParamString || 0 >= m_iParamLength )	return FALSE;
		if( 0 > _iIdx || m_iEntry <= _iIdx )			return FALSE;
		
		return ( 0 < STRING_len( GetString( _iIdx ) ) );
	}

	//********************************************************************************************
	/**
	 * @brief		̎擾.
 	 *				ɃT[`Ă镪ׂ͂邪eʂƐȂD.
	 * @author		N.Takeda
	 * @date		2011/05/30() 21:20:34
	 *
	 * @param[in]	const Int32	_iIdx		ԍ.
	 * @param[in]	LPCTSTR		_pDefStr	(ȗNULL).
	 *
	 * @return		LPTSTR	|C^.
	 */
	//********************************************************************************************
	LPTSTR	GetString( const Int32 _iIdx, LPCTSTR _pDefStr = NULL )
	{
		if( !m_pParamString || 0 >= m_iParamLength )	return (LPTSTR)_pDefStr;
		if( 0 > _iIdx || m_iEntry <= _iIdx )			return (LPTSTR)_pDefStr;
		Int32	iPtr = 0;
		
		for( Int32 ii=0 ; ii<_iIdx ; ii++ )
		{
			while( '\0' != *(m_pParamString + iPtr ) && m_iParamLength > iPtr)	iPtr += STRING_len( m_pParamString + iPtr );
			while( '\0' == *(m_pParamString + iPtr ) && m_iParamLength > iPtr)	iPtr++;
		}
		return m_pParamString + iPtr;
	}

	//********************************************************************************************
	/**
	 * @brief		p[^𐔒lƂĎ擾.
	 * @author		N.Takeda
	 * @date		2011/05/30() 21:51:39
	 *
	 * @param[in]	const Int32	_iIdx		ԍ.
	 * @param[in]	const Int32	_iDefVal	(ȗ0).
	 *
	 * @return		Int32	
	 */
	//********************************************************************************************
	Int32	GetInt( const Int32 _iIdx, const Int32 _iDefVal = 0 )
	{
		LPCTSTR		pp = GetString( _iIdx );
		if( !pp )	return _iDefVal;
		return STRING_atoi( pp );
	}

	//********************************************************************************************
	/**
	 * @brief		RXgN^.
	 * @author		N.Takeda
	 * @date		2011/05/30() 18:34:24
	 *
	 * @param[in]	LPCTSTR	_pParamString	Ă͂Ȃ.
	 *
	 * @return		Ȃ (none)
	 */
	//********************************************************************************************
	CEzParam( LPCTSTR _pParamString )
	 : m_pParamString( NULL )
	 , m_iParamLength( 0 )
	 , m_pBuff( NULL )	///< obt@.
	 , m_iEntry( 0 )	///< p[^.
	{
		m_iParamLength = STRING_len(_pParamString);
		
		if( 0 < m_iParamLength )
		{
			enum{	enAlinByte = 64	};
			Int32	iLength = (((m_iParamLength+1) + (enAlinByte-1)) / enAlinByte) * enAlinByte;
			
			/// ŊmۂăRs[.
			mem_alloc( TCHAR, m_pBuff, iLength );
			STRING_cpy( m_pBuff, _pParamString );
		}
		
		m_pParamString = m_pBuff;
		
		initialize();
	};
	
	//********************************************************************************************
	/**
	 * @brief		RXgN^.
	 * @author		N.Takeda
	 * @date		2011/05/30() 18:34:49
	 *
	 * @param[in]	LPTSTR	_pParamString	Ă悢.
	 *
	 * @return		Ȃ (none)
	 */
	//********************************************************************************************
	CEzParam( LPTSTR _pParamString )
	 : m_pParamString( _pParamString )
	 , m_iParamLength( 0 )
	 , m_pBuff( NULL )	///< obt@.
	 , m_iEntry( 0 )	///< p[^.
	{
		
		m_iParamLength = STRING_len(_pParamString);
		
		initialize();
	};
	
	//********************************************************************************************
	/**
	 * @brief		fXgN^.
	 * @author		N.Takeda
	 * @date		2011/05/30() 18:34:30
	 *
	 * @return		Ȃ (none)
	 */
	//********************************************************************************************
	virtual ~CEzParam()
	{
		
		mem_del( m_pBuff );
		
	};
	
	
#ifdef _DEBUG
	//********************************************************************************************
	/**
	 * @brief		Trace֐.
	 * @author		N.Takeda
	 * @date		2011/05/30() 21:49:54
	 *
	 * @return		Ȃ (none)
	 */
	//********************************************************************************************
	void	Trace()
	{
		TRACE( TEXT("%d\n"), GetEntry() );
		
		for( Int32 ii=0 ; ii<GetEntry() ; ii++ ){
			TRACE( TEXT("%2d:%s\n"), ii, GetString(ii) );
		}
	}
#endif
};

#endif /* _EZPARAM_H_ d`h~ */
// @edulcni system\ezParam.h
// @include system\stDump.h
//********************************************************************************************
/**
 * @file		stDump.h
 * @brief		v
	
		̃t@C̏ڍא
 * 
 * @author		N.Takeda
 * @date		2011/04/04() 21:19:32
 */
//********************************************************************************************


#define		_ALINE(num,aline)		((((num)+(aline-1))/aline)*aline)
#define		_ALINE8(num)			_ALINE(num,8)
#define		_ALINE4(num)			_ALINE(num,4)
#define		_ALINE1(num)			(num)


//********************************************************************************************
/**
 * @class		CStDump
 * @brief		
 * @author		N.Takeda
 * @date		2011/04/04() 21:19:32
 */
//********************************************************************************************
class	CStDump
{
	enum{	enDefaultRowNum = 16	};	///< ftHg̃oCg.
	
	enum{	enPointerByteLength = 4	};	///< |C^̃oCg.
public:
	
	/// ^.
	enum EnMethodType
	{
		enMethodTypeBuff,				///< obt@(͕Ɠ).
		enMethodTypeString,				///< .
#ifdef	_UNICODE
		enMethodTypeSJIS,				///< S-JIS.
#else
		enMethodTypeUNICODE,			///< UNICODE.
#endif
		enMethodTypeInt,				///< l.
		enMethodTypeUInt,				///< Ȃl.
		enMethodTypeHexInt,				///< 16il.
		enMethodTypeFloat,				///< _l.
		enMethodTypePointer,			///< |C^.
		enMethodTypeMax,
	};

	/// \̏ \.
	struct	StMethodInfo
	{
		EnMethodType	m_eType;		///< \bh̃^Cv.
		Int32			m_iSize;		///< TCY(byte).
	};
	
	static Int32	StructDump( LPTSTR _pBuff, const Int32 _iBuffSize, const void *_pPtr, const Int32 _iSize, StMethodInfo *_pMInfi = NULL, const Int32 _iRowNum = enDefaultRowNum );

private:
	static Int32	buffPrintf( LPTSTR _pBuff, const Int32 _iBuffSize, LPCTSTR _pFormat, ... );
	static Bool		viewBuff( Int32 &iBuffLen, LPTSTR _pBuff, const Int32 _iBuffSize, UInt8 *_pLineTopPtr, const Int32 _iSize, const Bool _bBeforeOver );
	static Bool		viewString( Int32 &_iBuffLen, LPTSTR _pBuff, const Int32 _iBuffSize, const UInt8 *_pStateTopPtr, const Int32 _iStateLength, const Bool _bBeforeOver );
	static Int64	getValue( UInt8 *_pLineTopPtr, const Int32 _iSize, const LPCTSTR _pLabel );
	static Float64	getFloatValue( UInt8 *_pLineTopPtr, const Int32 _iSize, const LPCTSTR _pLabel );
};


//********************************************************************************************
/**
 * @class		CInt2Str
 * @brief		64rbg^l𕶎ϊ.
 *				 %ld %ud Ȃŗp.

		UInt32̍ől	0xffffffff -> 4294967295
		Int64̍ől	0x7fffffffffffffff -> 9223372036854775807
		UInt64̍ől	0xffffffffffffffff -> 18446744073709551615

	CInt2Str<Int64>	obj;
	printf( "%s", obj.From( 18446744073709551615LL ) );

 * @author		N.Takeda
 * @date		2011/05/24() 16:43:29
 */
//********************************************************************************************
template <class T> class CInt2Str
{
	enum{	enBuffSize = 24	};	///< WJobt@TCY(21΂悢).
public:
	//********************************************************************************************
	/**
	 * @brief		From֐.
	 * @author		N.Takeda
	 * @date		2011/05/24() 17:05:17
	 *
	 * @param[in]	const T		_Value	l.
	 * @param[in]	const Int32	_iSinsu	16w肷16i\L(ȗ10).
	 *
	 * @return		char*	ϊ.
	 */
	//********************************************************************************************
	char	*From( const T _Value, const Int32 _iSinsu=10 )
	{
		T		iTemp = _Value;
		Int32	iKeta = 0;
		TCHAR	cBase = '0';
		Int32	iNum = 0;
		
		while( 0 != iTemp )
		{
			iKeta++;
			iTemp /= _iSinsu;
		}
		if( 0 == iKeta )	iKeta = 1;
		if( 0 > _Value )	iKeta++;
		if( iKeta >= enBuffSize )	return NULL;
		
		iTemp = _Value;
		if( 0 > _Value )	iTemp *= -1;
		
		m_sWork[ iKeta ] = 0;
		for( Int32 ii=iKeta-1 ; ii >= 0 ; ii-- )
		{
			iNum = static_cast<Int32>( iTemp % _iSinsu );
			cBase = ( 10 > iNum ) ? '0' : 'a';
			m_sWork[ ii ] = cBase + static_cast<TCHAR>(iNum);
			iTemp /= _iSinsu;
		}
		if( 0 > _Value )	m_sWork[ 0 ] = '-';
		
		return m_sWork;
	}
private:
	TCHAR	m_sWork[ enBuffSize ];
};

// @edulcni system\stDump.h

#if defined( PLATFORM_WIN32 )
// @include graphic\bmp.h
//********************************************************************************************
/**
 * @file		bmp.h
 * @brief		rbg}bv֘A
	
		̃t@C̏ڍא
 * 
 * @author		N.Takeda
 * @date		2011/06/20() 20:12:11
 */
//********************************************************************************************

#ifndef	_BMP_H_	// d`h~
#define	_BMP_H_	// d`h~}N


//----------------------------------
//	rbg}bv\			
//----------------------------------
struct	BMPINFO{
	LPVOID			lpBuf;					// obt@̃|C^
	
	LPBITMAPINFO	lpBMPInfo;				// rbg}bvCtH[V
	
	unsigned char	*lpIMG;					// BipmapҰޕ|C^
	UInt32			PTx;					// XW𓾂邽߂XW𑀍삷l@(^)
	UInt32			PTwid;					// YWړۂɉZl
	
	UInt32			Height;					// BMP̍
	UInt32			Width;					// BMP̕
	UInt16			BitCount;				// PhbĝrbgJEg
	
	UInt16			wPalMax;				// ۂɎgpĂpbg
};


//----------------------------------
//	rbg}bv]p\		
//----------------------------------
struct	BMPRECT{
	UInt32	x0;			// ]alon_
	UInt32	y0;			// ]alon_
	
	UInt32	x1;			// ]alon_
	UInt32	y1;			// ]alon_
	
	UInt32	dx;			// ]
	UInt32	dy;			// ]
	
	BMPINFO	bmpSI;		// ]
	BMPINFO	bmpDI;		// ]
	
	int		trans;		// Fw	(0:ׂRs[) (1:Fw) (2:) (3:͈͓)
	UInt32	col;		// FƂȂJ[R[h@܂RGBl
	int		ptrn;		// ]p^[	(0:sgp@(1:2:3:4:p^[0`3)
};


//--------------------------------------
//		pbg\				
//--------------------------------------
struct	PALETTE{
	int			PALETTEMAX;					// gppbgGg[
	
	HPALETTE	hPalette;					// pbgnh
	HPALETTE	hSysPalette;				// cb̈ȑÕpbg
//	LOGPALETTE	*lpSysPalKeep;
	LOGPALETTE	*lpLogPalette;				// _pbgi[obt@|C^
	
	char		*memPal;
};


//--------------------------------------
//		VXeJ[ۑp\		
//--------------------------------------
struct	PALETTE_SYS{
	int			Entry;						// VXeJ[Gg[
	int			nIndex[20];					// VXeJ[ԍ
	COLORREF	rgb[20];					// VXeJ[̂qfal
};


#define	_RGBA(r,g,b,a)	((a<<24)+(b<<16)+(g<<8)+r)


//	sbg}bvɂĕKvȃp[^\̂ɃZbg
BMPINFO	BMP_GetRECTinfo(LPVOID lpBuf);


void	BMP_draw( HDC DC, int X, int Y ,BMPINFO *bmp);
void	BMP_drawRECT( HDC DC, int X, int Y ,int sx,int sy,int dx,int dy,BMPINFO *bmp);

void	BMP_drawRS( HDC DC, int X, int Y ,BMPINFO *bmp,UInt32 dwRop);
void	BMP_drawRSRECT( HDC DC, int X, int Y ,int sx,int sy,int dx,int dy,BMPINFO *bmp,UInt32 dwRop);


/*----------------------------------------------------------
	alo摜wcb֕`

void	BMP_draw( HDC DC, int X, int Y ,LPVOID lpBuffer);

@
	HDC			`scb
	int			`cb̂wW
	int			`cb̂xW
	LPVOID		aloi[obt@
@߂l
	Ȃ
----------------------------------------------------------*/
void	BMP_draw( HDC DC, int X, int Y ,LPVOID lpBuffer);
/*	l
wcb̎w̍Wւalo`B
alo̓C[Ŵ܂ܓ]BIɕ`悵ꍇBMP_drawRECT̕gB

̊֐sł̓pbg͍킳Ȃ̂ŁÅ֐ ĂяoOɃpbg
ݒ肷KvB
*/


/*----------------------------------------------------------
	alo摜wcb֕`

void	BMP_drawRECT( HDC DC, int X, int Y ,int sx,int sy,int dx,int dy,LPVOID lpBuffer);

@
	HDC			`scb
	int			`cb̂wW
	int			`cb̂xW
	int			alôwW
	int			alôxW
	int			Rs[镝
	int			Rs[鍂
	LPVOID		aloi[obt@
@߂l
	Ȃ
----------------------------------------------------------*/
void	BMP_drawRECT( HDC DC, int X, int Y ,int sx,int sy,int dx,int dy,LPVOID lpBuffer);
/*	l
wcb̎w̍Wւalo`B

̊֐sł̓pbg͍킳Ȃ̂ŁÅ֐ ĂяoOɃpbg
ݒ肷KvB
*/




/*----------------------------------------------------------
	alo摜Rs[

void	BMP_Copy(BMPRECT *ts);

@
	BMPRECT		
@߂l
	Ȃ
----------------------------------------------------------*/
void	BMP_Copy(BMPRECT *ts);
/*	l

*/


/*----------------------------------------------------------
	alo摜Rs[@

void	BMP_CopyEZ(BMPINFO si,int x0,int y0,BMPINFO di,int x1,int y1,int dx,int dy,int trans);

@
	
@߂l
	Ȃ
----------------------------------------------------------*/
void	BMP_CopyEZ(BMPINFO si,int x0,int y0,BMPINFO di,int x1,int y1,int dx,int dy,int trans);



/*---------------------------------------------------------------------
	rbg}bv쐬Ԑ

UInt32	BMP_Create( char **mem, LONG BiWidth, LONG BiHeight, UInt16 TypeColor, LONG BiXPelsPerMeter, LONG BiYPelsPerMeter);

	
		char**		쐬rbg}bvi[郁\
		LONG		
		LONG		
		UInt16		PsNZ̃rbg     16F:4  256F:8
		LONG		𑜓x                   W 72
		LONG		𑜓x                   W 72
	߂l
		UInt32		쐬ꂽBMP̃TCY@s:0
---------------------------------------------------------------------*/
UInt32	BMP_Create( char **mem, LONG BiWidth, LONG BiHeight, UInt16 TypeColor, LONG BiXPelsPerMeter, LONG BiYPelsPerMeter);


/*---------------------------------------------------------------------
	wEBhEBMPɂĊi[

in:
		HWND		XN[VbgΏۂ̃EChEnh
		RECT*		Vbgʂ͈̔́@right,bottopm͕ƍ
		char*		BMP̊i[|C^̃|C^@ tnew 
out:
		UInt32		쐬ꂽBMP̃TCY
---------------------------------------------------------------------*/
UInt32	BMP_windowshot(HWND hWnd,RECT *rc,char **mptr);
#define	BMPbits(ptr)	(*(UInt16*)(ptr+sizeof(BITMAPFILEHEADER)+sizeof(UInt32)*3+sizeof(UInt16)))


/*---------------------------------------------------------------------
	rbg}bvpbgRs[

Bool	BMP_PaletteCopy( BMPINFO lpOrigin, BMPINFO lpAhend, UInt32	Si, UInt32 Di, UInt32 Dt);

	
		BMPINFO		Rs[
		BMPINFO		Rs[
		UInt32		]pbgCfbNX
		UInt32		]pbgCfbNX
		UInt32		]
	߂l
		Es
---------------------------------------------------------------------*/
Bool	BMP_PaletteCopy( BMPINFO lpOrigin, BMPINFO lpAhend, UInt32	Si, UInt32 Di, UInt32 Dt);


/*----------------------------------------------------------
	walõpbg_pbg̔Cӂ̏ꏊփZbg

void	BMP_PalTranslate(PALETTE Palette,BMPINFO bmp,UInt16 wStartIndex, UInt16 wNumEntries);

@
	PALETTE		pbg\
	BMPINFO		gppbg܂񂾃rbg}bv\
	UInt16		pbggpJnԍ
	UInt16		pbggpIԍ
@߂l
	Ȃ
----------------------------------------------------------*/
void	BMP_PalTranslate(PALETTE Palette,BMPINFO bmp,UInt16 wStartIndex, UInt16 wNumEntries);


/*----------------------------------------------------------
	_pbg쐬

PALETTE	PALETTE_set( HWND hWnd ,int PALETTEMAX);

@
	HWND		EBhEnh
	int			pbgɎgpőF
@߂l
	PALETTE		pbg\
----------------------------------------------------------*/
PALETTE	PALETTE_set( HWND hWnd ,int PALETTEMAX);
/*	l
AvP[VŎgp_pbg쐬B
ŗ̈mۂsĂ̂ŏIɂ͕KPALETTE_freeĂяoB

@PALETTEMAX256w肷ƎIɃVXeJ[QFɗƂB
ȊȌꍇ͒ʏʂQOF̃VXeJ[B

_pbg͕쐬邱Ƃ\AʏP̃AvP[VɂPłB
*/


/*----------------------------------------------------------
	_pbgJ

void	PALETTE_free(HWND hWnd, PALETTE Palette);

@
	HWND		EBhEnh
	PALETTE		pbg\
@߂l
	Ȃ
----------------------------------------------------------*/
void	PALETTE_free(HWND hWnd, PALETTE Palette);



/*--------------------------------------------------------------
	{bNXt`
--------------------------------------------------------------*/
void	DRAW_boxful(HDC DC,int x,int y,int x1,int y1,COLORREF rgb);


/*--------------------------------------------------------------
	{bNX`
---------------------------------------------------------------*/
void	DRAW_box(HDC DC,int x,int y,int x1,int y1,COLORREF rgb);


/*---------------------------------------------------------------------
	w肵W̃J[R[h𓾂@256/16 Ή

IN:
		BMPINFO*	bmpinfo		rbg}bv
		int			x			W
		int			y			W
OUT:
		UInt32		J[R[h
---------------------------------------------------------------------*/
UInt32	BMP_getpixel(BMPINFO *bmpinfo,int x,int y);

/*---------------------------------------------------------------------
	rbg}bv̎w肵WɃJ[R[hZbg

IN:
		BMPINFO*	bmpinfo		rbg}bv
		int			x			W
		int			y			W
		UInt32		col			J[R[h
---------------------------------------------------------------------*/
void	BMP_setpixel(BMPINFO *bmpinfo,int x,int y,UInt32 col);

/*---------------------------------------------------------------------
	wJ[R[hRGBl𓾂

IN:
		BMPINFO*	bmpinfo		rbg}bv
		int			col			J[R[h
OUT:
		UInt32		RGBl@J[I[o[Ăꍇ͂OԂ
---------------------------------------------------------------------*/
UInt32	BMP_getpalette(BMPINFO *bmpinfo,int col);

/*---------------------------------------------------------------------
	wJ[R[hRGBlZbg

IN:
		BMPINFO*	bmpinfo		rbg}bv
		int			col			J[R[h
		UInt32		rgb			RGBl
OUT:
		Bool		J[I[o[Ăꍇ͂OԂ@ȊO͂P
---------------------------------------------------------------------*/
Bool	BMP_setpalette(BMPINFO *bmpinfo,int col,UInt32 rgb);


/*---------------------------------------------------------------------
	rbg}bvtJ[rbg}bvɕϊ

int		BMP_to24RGB( BMPINFO bmpSi, char **memDi );

IN;
		char		*memSi		
		char		**memDi		
OUT:
		int			ϊTCY

@ tnew ĂяoĂ
---------------------------------------------------------------------*/
int		BMP_to24RGB( char *memSi, char **memDi );
int		BMP_to32RGB( char *memSi, char **memDi );	//	}XN 0xff


//		pbg\@fobOp֐
void	VIEW_palette(HDC DC,int sx,int sy,int dx,int dy,PALETTE Palette);
void	VIEW_paletteINDEX(HDC DC,int sx,int sy,int dx,int dy);
void	VIEW_paletteSYSTEM(HDC DC,int sx,int sy,int dx,int dy);


#endif // _BMP_H_ d`h~
// @edulcni graphic\bmp.h
// @include graphic\font.h
//********************************************************************************************
/**
 * @file		font.h
 * @brief		tHg֘A
	
		̃t@C̏ڍא
 * 
 * @author		N.Takeda
 * @date		2011/06/20() 20:11:49
 */
//********************************************************************************************

#ifndef	_FONT_H_	// d`h~
#define	_FONT_H_	// d`h~}N


//--------------------------
//	tHg\			
//--------------------------
struct	FONTRGB{
	LOGFONT         MyFont;
	UInt32			rgb;
};
//	OtHgɐF̂


/*----------------------------------------------------------
		w̕w̏ŕ\

void	FONT_TextOut( HDC DC, unsigned char *lpStr, int x, int y, FONTRGB *font,int length);

@
	HDC		foCXReLXg
	char*	\
	int		\ X W
	int		\ Y W
	FONTRGB	tHg̎
	int		o͕
  ߂l
	Ȃ
----------------------------------------------------------*/
void	FONT_TextOut( HDC DC, unsigned char *lpStr, int x, int y, FONTRGB *font,int length);


/*----------------------------------------------------------
		tHgݒ肷

FONTRGB	FONT_set( int nFont, int MojiSpace, int lfHeight,UInt32 rgb);

@
	int		tHg̎
	int		
	int		
  ߂l
	tHg\
----------------------------------------------------------*/
FONTRGB	FONT_set( int nFont, int MojiSpace, int lfHeight,UInt32 rgb);


//======================================================================================
//		̑
//======================================================================================


/*--------------------------------------------------------------------------------------
	ϊEBhE̕\^\؂ւ

Bool	IME_windowActive(HWND hWnd,int sw);

@
	HWND		EBhEnh
	int			p[^@TRUE:ANeBu FALSE:ANeBu ȊO:ύXȂ
@߂l
	Bool		sȌ
--------------------------------------------------------------------------------------*/
Bool	IME_windowActive(HWND hWnd,int sw);
/*	l
@p[^ TRUE/FALSE ȊO̒l^ƌ݂̏Ԃ擾邱ƂłB
*/



/*--------------------------------------------------------------------------------------
	̕ϊO̕̕\ʒuݒ肵܂B

void	IME_SetCaret(HWND hWnd,int x,int y);

@
	HWND		EBhEnh
	int		x	\W
	int		y	\W
@߂l
	Bool		sȌ
--------------------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------------------
void	IME_SetCaret(HWND hWnd,int x,int y);

@
	HWND		EBhEnh
	int		x	\W
	int		y	\W
@߂l
	Bool		sȌ
--------------------------------------------------------------------------------------*/
void	IME_SetCaret(HWND hWnd,int x,int y);


#endif // _FONT_H_ d`h~
// @edulcni graphic\font.h
#endif	// PLATFORM_WIN32

#else

//#include <winnls32.h>	//ꎞ~@KvɂȂ܂LɂĎOłdlɂ鎖
/// {.
#include "memory\tnew.h"
#include "types.h"

/// VXe֘A.
/// windowsŗL
#if defined( PLATFORM_WIN32 )
	#include "system\win32\assert.h"
	#include "system\win32\system.h"
	#include "system\win32\menu.h"				///< system.h ̌
	#include "system\win32\profile.h"
	#include "system\win32\clip.h"
	#include "system\win32\help.h"
	#include "system\win32\mouse.h"

	#include "files\files.h"
//	#include "files\xcopy.h"
#elif defined( PLATFORM_PSP )
	#include "system\psp\assert.h"

	#include "files\files.h"
#endif	// PLATFORM_

#include "memory\memory.h"

#include "string\string.h"
#include "string\Probuff.h"
#include "cul.h"

//#include "system\ezParam.h"
//#include "system\stDump.h"

/// fBA֘A.
#if defined( PLATFORM_WIN32 )
	#include "graphic\bmp.h"
	#include "graphic\font.h"
#endif	// PLATFORM_WIN32


// o[W݊p
#ifdef	USE_OLD_PATOL
#include "_junk/junk.h"
#endif
#endif








#define		lengthof(array)			(sizeof((array)) / sizeof((array[0])))

//		ϐregɑ΂ā@(0`val*2) ̒l (0`val)<->(val`0) ɕϊ
//			val=5̎@0`9 ̒l 0 1 2 3 4 5 4 3 2 1 ƂȂ
#define		CUL_BOUND(reg,val)		((reg<=val) ? reg : ((val*2)-reg))


//	WORD ̃f[^p@ʃoCgƉʃoCg𔽓]
#define	swap_word(code)	(((code)&0xff)*0x100+(code)/0x100)
#define	_WCHAR(ch)	(*((u_char*)ch)*0x100 + *((u_char*)ch+1))







#define	_message(mess)	MessageBox(NULL,mess,TEXT(""),MB_OK);


//		lQׂ̂ɒ
int		topow(int value);


//======================================================================================
//		oCi[_v֘A.
//======================================================================================
void	DUMP_stream32( LPCTSTR _szName,  UInt32 *_pPtr, UInt32 _iLength, Int32 _iRetNum );
void	DUMP_stream16( LPCTSTR _szName,  UInt16 *_pPtr, UInt32 _iLength, Int32 _iRetNum );
void	DUMP_stream8(  LPCTSTR _szName,  UInt8  *_pPtr, UInt32 _iLength, Int32 _iRetNum );
LPTSTR	DUMP_string32( LPTSTR _pBuffPtr, UInt32 *_pPtr, UInt32 _iLength, Int32 _iRetNum );
LPTSTR	DUMP_string16( LPTSTR _pBuffPtr, UInt16 *_pPtr, UInt32 _iLength, Int32 _iRetNum );
LPTSTR	DUMP_string8(  LPTSTR _pBuffPtr, UInt8  *_pPtr, UInt32 _iLength, Int32 _iRetNum );



//======================================================================================
//		tB^[֘A
//======================================================================================

//		ߕ̍폜
//UInt32	FILT_deleteREM( LPTSTR ptr,UInt32 length,LPTSTR remln,LPTSTR remst,LPTSTR remen,char strch );
UInt32	FILT_deleteREM( LPTSTR _pPtr, const UInt32 _iLength, LPCTSTR _pRemln = TEXT("//"), LPCTSTR _pRemst = TEXT("/*"), LPCTSTR _pRemen = TEXT("*/"), const TCHAR _cSymbleCh = '\"' );

//		]폜
UInt32	FILT_deleteSpace( LPTSTR _pBuff, const UInt32 _uLength, const TCHAR  _cSymbleCh );
UInt32	FILT_del_space( LPTSTR pBuff,UInt32 uLength,char st/*,const char *chkstr*/);//݊p
/// 	s̗]폜
Int32	FILT_deleteTailSpace( LPTSTR _pPtr, const Int32 _iLen );
inline	Int32	FILT_excessiveSPACE( LPTSTR _pPtr, const Int32 _iLen ){	return FILT_deleteTailSpace( _pPtr, _iLen );	}	///< ݊p(Oɂ̂ŕύX).

//		eLXg̐lZ
UInt32	FILT_culucurate( LPTSTR _pBuffer, const UInt32 _uSize = 0, const UInt32 _uStart = 0, const char _cStringSymble = '\"' );

//		eLXĝPUiPOiɕϊ
UInt32	FILT_hex2dec( LPTSTR ptr,UInt32 size,char *chkstr);

/// obt@̕"Ŋ(XNvg͗pAx^eLXg𕶎ɕϊ)
UInt32	FILT_StringRelief( LPTSTR _pBuff, UInt32 const _uLength, const TCHAR _cStrSS = '#', const Bool _bSubstSkip = TRUE, const TCHAR _cStrCh = '\"' );

/// obt@̕啶ɕϊB̓XLbv
void	FILT_ToBig( LPTSTR _pPtr, UInt32 _iLength, TCHAR _cStrCh = '\"' );
/// obt@̕ɕϊB̓XLbv
void	FILT_ToSmall( LPTSTR _pPtr, UInt32 _iLength, TCHAR _cStrCh = '\"' );

/// chaos.
UInt32	FILT_toString3( LPTSTR ptr,UInt32 length,LPTSTR chkstr,char strss,char strch );
/*
//		pŊꂽSp𕶎
UInt32	FILT_toString2( LPTSTR ptr,UInt32 length,LPTSTR chkstr,char strch );

//		啶
void	FILT_small2big( LPTSTR ptr,UInt32 length,char strch );
*/




//======================================================================================
//		fobO֘A
//			DEBUG_TRACE 𖳌ɂƂȂȂ̂ŕKvȏo͂ɑ΂ĎgȂ
//======================================================================================
#ifdef	DEBUG_TRACE
	#define	DEBUGSTREAM_NAME	TEXT("D.TXT")

	Bool	DEBUG_stream( LPCTSTR szName, LPCTSTR str );
	Bool	DEBUG_streamINT( LPCTSTR szName, int num );
	Bool	DEBUG_streamINTx( LPCTSTR szName, int num );
	Bool	DEBUG_streamCHAR( LPCTSTR szName, char ch );
	Bool	DEBUG_streamFLOAT( LPCTSTR szName, float dat );
	Bool	DEBUG_printf( LPCTSTR szName, LPCTSTR format, ... );
	Bool	DEBUG_message( LPCTSTR str );
	Bool	DEBUG_buffer( LPCTSTR szName, char *ptr, UInt32	length );
	Bool	DEBUG_strword( LPCTSTR szName, char *ptr );

	Bool	_printf( LPCTSTR format, ... );
#if defined( PLATFORM_WIN32 )
	void	DEBUG_LastError( LPTSTR _pBuff = NULL );
	void	WINDOW_GetMsgString( UINT _uMsg, LPTSTR _sString, Bool _bType = FALSE );
#endif	// PLATFORM_WIN32
	void	dprintf_real( const TCHAR * _fmt, ... );

//	ȗ
	#define	_crlf			DEBUG_stream( DEBUGSTREAM_NAME, TEXT("\r\n"))
	#define	_str(str)		{DEBUG_stream( DEBUGSTREAM_NAME, str);_crlf;}
	#define	_int(val)		DEBUG_streamINT( DEBUGSTREAM_NAME, val)
	#define	_intx(val)		DEBUG_streamINTx( DEBUGSTREAM_NAME, val)
	#define	_char(ch)		DEBUG_streamCHAR( DEBUGSTREAM_NAME, ch)
	#define	_float(val)		DEBUG_streamFLOAT( DEBUGSTREAM_NAME, val)
	#define	_gate(val)		DEBUG_printf( DEBUGSTREAM_NAME, TEXT("gate %d\r\n"), val)
	#define	_strwd(str)		{DEBUG_strword( DEBUGSTREAM_NAME, str);_crlf;}

	#define	TRACE			dprintf_real

#else
	#define	DEBUG_stream		__noop
	#define	DEBUG_streamINT		__noop
	#define	DEBUG_streamINTx	__noop
	#define	DEBUG_streamCHAR	__noop
	#define	DEBUG_streamFLOAT	__noop
	#define	DEBUG_printf		__noop
	#define	DEBUG_message		__noop
	#define	DEBUG_buffer		__noop
	#define	DEBUG_strword		__noop

	#define	_printf				__noop
#if defined( PLATFORM_WIN32 )
	#define	DEBUG_LastError		__noop
	#define	WINDOW_GetMsgString	__noop
#endif	// PLATFORM_WIN32

//	ȗ
	#define	_crlf				__noop
	#define	_str				__noop
	#define	_int				__noop
	#define	_intx				__noop
	#define	_char				__noop
	#define	_float				__noop
	#define	_gate				__noop
	#define	_strwd				__noop

	#define	TRACE				__noop
#endif


/*
void	DEBUG_TEXT_init();
int		DEBUG_TEXT_open(HANDLE hInstance, int cmdShow,int x,int y);
Bool	DEBUG_TEXT_put(int num,LPCTSTR str);
*/


/*----------------------------------------------------------
		I[gs[g␳

Bool	AutpRepeat(int d,int *cur_cnt,int AUTO_REP_CNT);

@
	int		{^Ă:1@{^Ă:0@Zbg
	int*	I[gs[gJE^[|C^
	int		s[gJEg
  ߂l
	Bool	TRUE:ғǂ@FALSE:~
----------------------------------------------------------*/
Bool	AutpRepeat(int d,int *cur_cnt,int AUTO_REP_CNT);




//======================================================================================
//		֘A
//======================================================================================

/*----------------------------------------------------------
	wt@C̃EF[uf[^Đ

Bool	WAVE_debug(char *FileName);

@
	char*		EF[uf[^̃t@C
@߂l
	Bool		TRUE:@FALSE s
----------------------------------------------------------*/
Bool	WAVE_debug( LPCTSTR FileName );

Bool	WAVE_play( LPCTSTR FileName );

Bool	WAVE_sound( LPCTSTR FileName, UInt32 option );

Bool	WAVE_bord();
Bool	WAVE_check();

void	randomize();
Int32	random( Int32 _iMax );

void	_swap( TCHAR &a, TCHAR &b );
void	_swap( int &a, int &b );
void	_swap( long &a, long &b );
void	_swap( float &a, float &b );
void	_swap( double &a, double &b );
void	_swap( LPTSTR a, LPTSTR b );


#endif /* _TOOLS_H_ */
